{
    This file is part of SkantiControl

    Skanti TRP8255 control program (CU8000 control unit)
    This program was developed for a CU8000 control unit marked
    TRP 8255 S R GB1. May work or not with other units.

    Copyright (C) 2012-2015 G. Perotti, I1EPJ, i1epj@aricasale.it

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/.
}

unit skanti;

{$mode objfpc}{$H+}

{$UNDEF DEBUG}
{$UNDEF TEST}
{$UNDEF TEST_USER_INTERFACE}
{$DEFINE BFOREPEAT}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Menus, ExtCtrls, Buttons, ComCtrls, serial, types, LCLType, ActnList, mouse,
  dateutils, user, UAbout, UGNU, UMAN, umanager;

type

  { TTRP }

  TTRP = class(TForm)
          BBFODN: TBitBtn;
          BBFOUP: TBitBtn;
          BAM: TBitBtn;
          BCW: TBitBtn;
          B500: TBitBtn;
          B2182: TBitBtn;
          BFULL: TBitBtn;
          BDUP: TBitBtn;
          BINTER: TBitBtn;
          BAGCON: TBitBtn;
          BAGCFAST: TBitBtn;
          BAGCSLOW: TBitBtn;
          BAGCOFF: TBitBtn;
          BSQL: TBitBtn;
          BRFATT: TBitBtn;
          BRFAMP: TBitBtn;
          BSPKR: TBitBtn;
          BMINUS: TButton;
          BRXEQTX: TButton;
          BVNAR: TBitBtn;
          BNAR: TBitBtn;
          BWIDE: TBitBtn;
          BSCAN: TBitBtn;
          BMED: TBitBtn;
          BLOW: TBitBtn;
          BMCW: TBitBtn;
          BR3E: TBitBtn;
          BTELEX: TBitBtn;
          BLSB: TBitBtn;
          BUSB: TBitBtn;
          BTUNEDN: TBitBtn;
          BTUNEUP: TBitBtn;
          BSENSUP: TBitBtn;
          BDIMDN: TBitBtn;
          BDIMUP: TBitBtn;
          BSENSDN: TBitBtn;
          BVOLUP: TBitBtn;
          BVOLDN: TBitBtn;
          BTXEQRX: TButton;
          MenuItem10: TMenuItem;
          MenuItem11: TMenuItem;
          MenuItem12: TMenuItem;
          MenuItem14: TMenuItem;
          MADVSCPTR: TMenuItem;
          MALWLP: TMenuItem;
          MChannels: TMenuItem;
          MDEFU: TMenuItem;
          MDISU: TMenuItem;
          MenuItem15: TMenuItem;
          MUSEUTC: TMenuItem;
          MMANCH: TMenuItem;
          MMANST: TMenuItem;
          MIMMU: TMenuItem;
          MSCHANN: TMenuItem;
          MRELCH: TMenuItem;
          MenuItem16: TMenuItem;
          MEXITCHAN: TMenuItem;
          MRSTSCBP: TMenuItem;
          MFILLBUF: TMenuItem;
          MTESTFMAUTO: TMenuItem;
          MTESTMAN: TMenuItem;
          MTESTFMMAN: TMenuItem;
          MSETGR: TMenuItem;
          MSETPR: TMenuItem;
          MSETOR: TMenuItem;
          MSHOWC: TMenuItem;
          MSTOBFO: TMenuItem;
          MRSTATE: TMenuItem;
          MSTPALRM: TMenuItem;
          MTSTALRM: TMenuItem;
          MSNDALRM: TMenuItem;
          MenuItem13: TMenuItem;
          MRed: TMenuItem;
          MGreen: TMenuItem;
          MYellow: TMenuItem;
          MenuItem2: TMenuItem;
          MenuItem6: TMenuItem;
          MenuItem7: TMenuItem;
          MenuItem8: TMenuItem;
          MenuItem9: TMenuItem;
          MTESTAUTO: TMenuItem;
          MSG: TMemo;
          MENALL: TMenuItem;
          MSETBFO: TMenuItem;
          MenuItem4: TMenuItem;
          MRESET: TMenuItem;
          MRELPRIO: TMenuItem;
          MenuItem3: TMenuItem;
          MOTFUN: TMenuItem;
          MGNULIC: TMenuItem;
          MABOUT: TMenuItem;
          MMAN: TMenuItem;
          MHelp: TMenuItem;
          MRCONF: TMenuItem;
          MLSTATE: TMenuItem;
          MSSTATE: TMenuItem;
          MenuItem5: TMenuItem;
          MRTU: TMenuItem;
          MRCU: TMenuItem;
          MRBFO: TMenuItem;
          MTRANS: TMenuItem;
          MStatus: TMenuItem;
          MenuItem1: TMenuItem;
          MCustom: TMenuItem;
          FLASH: TTimer;
          Clock: TTimer;
          OpenDialog1: TOpenDialog;
          SaveDialog1: TSaveDialog;
          SCUR: TShape;
          SM: TTimer;
          RXFreq: TStaticText;
          TXFUpTimer: TTimer;
          TXFreq: TStaticText;
          STRP1: TStaticText;
          STRP2: TStaticText;
          STSIG: TStaticText;
          STPWR: TStaticText;
          RPT: TTimer;
          WMeter: TProgressBar;
          SMETER: TProgressBar;
          TStatus: TTimer;
          STEP10H: TShape;
          Step100H: TShape;
          STEP1K: TShape;
          SPLOW: TShape;
          SRPWR: TShape;
          TX: TTimer;
          BRATE: TButton;
          BTUNE: TButton;
          BRX: TButton;
          BRCL: TButton;
          BTX: TButton;
          B7: TButton;
          B8: TButton;
          B9: TButton;
          B4: TButton;
          B5: TButton;
          B6: TButton;
          B1: TButton;
          B2: TButton;
          B3: TButton;
          BENTER: TButton;
          B0: TButton;
          BONOFF: TButton;
          BTXONOFF: TButton;
          BSTO: TButton;
          BSETT: TButton;
          BTRANS: TButton;
          MainMenu1: TMainMenu;
          MFile: TMenuItem;
          M300b: TMenuItem;
          M2400B: TMenuItem;
          MExit: TMenuItem;
          MOptions: TMenuItem;
          MPort: TMenuItem;
          MSpeed: TMenuItem;
          Mttys0: TMenuItem;
          Mttys1: TMenuItem;
          procedure BAGCFASTClick(Sender: TObject);
          procedure BAGCOFFClick(Sender: TObject);
          procedure BAGCONClick(Sender: TObject);
          procedure BAGCSLOWClick(Sender: TObject);
          procedure B2182Click(Sender: TObject);
          procedure B4Click(Sender: TObject);
          procedure B7Click(Sender: TObject);
          procedure B8Click(Sender: TObject);
          procedure B9Click(Sender: TObject);
          procedure BBFODNMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BBFODNMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BBFOUPClick(Sender: TObject);
          procedure BBFOUPMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BBFOUPMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BDIMDNMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BDIMDNMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BDIMUPMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BDIMUPMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BDUPClick(Sender: TObject);
          procedure BRXEQTXClick(Sender: TObject);
          procedure BSCANClick(Sender: TObject);
          procedure BSENSDNClick(Sender: TObject);
          procedure BSENSDNMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BSENSDNMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BSENSUPMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BSENSUPMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BSETTClick(Sender: TObject);
          procedure BMINUSClick(Sender: TObject);
          procedure BTELEXClick(Sender: TObject);
          procedure BTUNEDNMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BTUNEDNMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BTUNEUPClick(Sender: TObject);
          procedure BFULLClick(Sender: TObject);
          procedure BBFODNClick(Sender: TObject);
          procedure BTUNEDNClick(Sender: TObject);
          procedure BSENSUPClick(Sender: TObject);
          procedure BDIMDNClick(Sender: TObject);
          procedure BDIMUPClick(Sender: TObject);
          procedure B500Click(Sender: TObject);
          procedure BTUNEUPMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BTUNEUPMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BVOLDNClick(Sender: TObject);
          procedure BLOWClick(Sender: TObject);
          procedure BMEDClick(Sender: TObject);
          procedure BRCLClick(Sender: TObject);
          procedure BRFATTClick(Sender: TObject);
          procedure BSQLClick(Sender: TObject);
          procedure BTXEQRXClick(Sender: TObject);
          procedure BRATEClick(Sender: TObject);
          procedure BRXClick(Sender: TObject);
          procedure BTXClick(Sender: TObject);
          procedure B5Click(Sender: TObject);
          procedure B6Click(Sender: TObject);
          procedure B2Click(Sender: TObject);
          procedure B3Click(Sender: TObject);
          procedure B0Click(Sender: TObject);
          procedure BTXONOFFClick(Sender: TObject);
          procedure BVOLDNMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BVOLDNMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BVOLUPClick(Sender: TObject);
          procedure BVOLUPMouseDown(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BVOLUPMouseUp(Sender: TObject; Button: TMouseButton;
                  Shift: TShiftState; X, Y: Integer);
          procedure BWIDEClick(Sender: TObject);
          procedure BTRANSClick(Sender: TObject);
          procedure BINTERClick(Sender: TObject);
          procedure BNARClick(Sender: TObject);
          procedure BVNARClick(Sender: TObject);
          procedure BSPKRClick(Sender: TObject);
          procedure BRFAMPClick(Sender: TObject);
          procedure BSTOClick(Sender: TObject);
          procedure ClockTimer(Sender: TObject);
          procedure BENTERClick(Sender: TObject);
          procedure BMCWClick(Sender: TObject);
          procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
          procedure FormKeyDown(Sender: TObject; var Key: Word;
              Shift: TShiftState);
          procedure FormResize(Sender: TObject);
          procedure MABOUTClick(Sender: TObject);
          procedure MADVSCPTRClick(Sender: TObject);
          procedure MALWLPClick(Sender: TObject);
          procedure MDEFUClick(Sender: TObject);
          procedure MDISUClick(Sender: TObject);
          procedure MENALLClick(Sender: TObject);
          procedure MUSEUTCClick(Sender: TObject);
          procedure MMANCHClick(Sender: TObject);
          procedure MMANSTClick(Sender: TObject);
          procedure MIMMUClick(Sender: TObject);
          procedure MRELCHClick(Sender: TObject);
          procedure MEXITCHANClick(Sender: TObject);
          procedure MFILLBUFClick(Sender: TObject);
          procedure MRSTSCBPClick(Sender: TObject);
          procedure MSGDblClick(Sender: TObject);
          procedure MStatusClick(Sender: TObject);
          procedure MTESTFMAUTOClick(Sender: TObject);
          procedure MTESTFMMANClick(Sender: TObject);
          procedure MGreenClick(Sender: TObject);
          procedure MRedClick(Sender: TObject);
          procedure MRSTATEClick(Sender: TObject);
          procedure MSETBFOClick(Sender: TObject);
          procedure MGNULICClick(Sender: TObject);
          procedure MLSTATEClick(Sender: TObject);
          procedure MMANClick(Sender: TObject);
          procedure MRCONFClick(Sender: TObject);
          procedure MRELPRIOClick(Sender: TObject);
          procedure MRESETClick(Sender: TObject);
          procedure MRTUClick(Sender: TObject);
          procedure MExitClick(Sender: TObject);
          procedure MRBFOClick(Sender: TObject);
          procedure MRCUClick(Sender: TObject);
          procedure MSETGRClick(Sender: TObject);
          procedure MSETORClick(Sender: TObject);
          procedure MSETPRClick(Sender: TObject);
          procedure MSHOWCClick(Sender: TObject);
          procedure MSNDALRMClick(Sender: TObject);
          procedure MSSTATEClick(Sender: TObject);
          procedure MSTOBFOClick(Sender: TObject);
          procedure MSTPALRMClick(Sender: TObject);
          procedure MTESTAUTOClick(Sender: TObject);
          procedure MTESTMANClick(Sender: TObject);
          procedure MTSTALRMClick(Sender: TObject);
          procedure MYellowClick(Sender: TObject);
          procedure RPTTimer(Sender: TObject);
          procedure RXfreqMouseUp(Sender: TObject; Button: TMouseButton;
                    Shift: TShiftState; X, Y: Integer);
          procedure STEP100HMouseUp(Sender: TObject; Button: TMouseButton;
                    Shift: TShiftState; X, Y: Integer);
          procedure STEP10HMouseUp(Sender: TObject; Button: TMouseButton;
                    Shift: TShiftState; X, Y: Integer);
          procedure STEP1KMouseUp(Sender: TObject; Button: TMouseButton;
                    Shift: TShiftState; X, Y: Integer);
          procedure FLASHTimer(Sender: TObject);
          procedure SMTimer(Sender: TObject);
          procedure TStatusTimer(Sender: TObject);
          procedure BTUNEClick(Sender: TObject);
          procedure B1Click(Sender: TObject);
          procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
                    WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
          procedure BONOFFClick(Sender: TObject);
          procedure BCWClick(Sender: TObject);
          procedure FormCreate(Sender: TObject);
          procedure M2400BClick(Sender: TObject);
          procedure M300BClick(Sender: TObject);
          procedure MCustomClick(Sender: TObject);
          procedure Mttys0Click(Sender: TObject);
          procedure Mttys1Click(Sender: TObject);
          procedure BLSBClick(Sender: TObject);
          procedure BAMClick(Sender: TObject);
          procedure BR3EClick(Sender: TObject);
          procedure TXfreqMouseUp(Sender: TObject; Button: TMouseButton;
                    Shift: TShiftState; X, Y: Integer);
          procedure TXFUpTimerTimer(Sender: TObject);
          procedure TXTimer(Sender: TObject);
          procedure BUSBClick(Sender: TObject);
          procedure KeyboardHandler(keyp: string);
          procedure DispRXf;
          procedure DispTXf;
          procedure UpdatePanel;
          function SendCommand(cmd, par: string): boolean;
          function GetReply(ReplyLen: integer; ReplyTimeout: extended): string;
          function OpenRemote: boolean;
          function CloseRemote: boolean;
          function SetRXFreq: boolean;
          function SetTXFreq: boolean;
          function SetRXMode: boolean;
          function SetTXMode: boolean;
          function SetRXTXFreq: boolean;
          procedure SaveLastState;
          procedure LoadLastState;
          procedure LoadChannel(Sender: TObject);
          procedure RestoreState;
          procedure SetDefaultState;
          procedure SaveConfig;
          procedure ReadConfig;
          procedure LoadChannelsDir;
          procedure Message(ms: string);
          function FormatBFOFreq(s: string): string;
          procedure DisableAllControls;
          procedure DisableAllButtons;
          procedure EnableAllControls;
          procedure SetAllLEDsOff;
          function GetAutoSelfTestResponse: boolean;
          function GetManSelfTestResponse: boolean;
          procedure SetActiveButtons;
          procedure CloseProgram;
          function AdjustDecimalSeparator(s: string): string;

  private
            { private declarations }
  public
            { public declarations }
  end;

Const
  // Version string
  SVersion:       string = 'v0.83 (C) 2012-2015 G. Perotti, I1EPJ';
  //
  // Skanti command values
  //
  RemoteEnable:   String = #1#2;    // SOH STX
  RemoteDisable:  String = #16;     // DLE
  RTX_Reset:      String = '!';     // Reset
  TX_Cmd:         String = '"';     // " Double quote mark (has 3 sec timeout)
  RX_Cmd:         String = '#';     // #

  TX_Prefix:      String = ';';     // ; + ASCII value + cr
  RX_Prefix:      String = ':';     // : + ASCII value + cr
  //	NOTE!  The value represents the frequency in multiples of 100Hz

  Recall:         String = '<';     // + ASCII value + cr
  Tune_Dn:        String = '=';     // TUNE down. See 'w'
  Tune_Up:        String = '>';     // TUNE up. See 'w'
  BFO_Tune_Dn:    String = '@';     // CW Beat tone Down 100Hz
  BFO_Tune_Up:    String = 'A';     // CW Beat tone Up 100Hz
  Filt_Wide:      String = 'B';     // Where enabled
  Filt_Inter:     String = 'C';     // Where enabled
  Filt_Narrow:    String = 'D';     // Where enabled
  Filt_VNarrow:   String = 'E';     // Where enabled
  Speaker_Toggle: String = 'F';     // Toggle On/Off
  PreAmp_Toggle:  String = 'G';     // Toggle On/Off
  Atten_Toggle:   String = 'H';     // Toggle On/Off
  Squelch_Toggle: String = 'I';     // Toggle On/Off
  Agc_On:         String = 'J';
  Agc_Fast:       String = 'K';
  Agc_Slow:       String = 'L';
  Agc_Off:        String = 'M';
  Sensitivity_Dn: String = 'N';     // Increment RF Gain Down (AGC must be OFF)
  Sensitivity_Up: String = 'O';     // Increment RF Gain Up (AGC must be OFF)
  AF_GainDec:     String = 'P';     // 'P';     // Increment Volume DAC Down.
  AF_GainInc:     String = 'Q';     // 'Q';     // Increment Volume DAC Up.
  TX_Tune:        String = 'R';     // Invoke TX tuning.
  TX_LowPwr:      String = 'S';
  TX_MediumPwr:   String = 'U';
  TX_HighPwr:     String = 'W';
  Mode_USB:       String = 'X';
  Mode_LSB:       String = 'Y';
  Mode_AM:        String = 'Z';
  Mode_Telex:     String = '[';
  Mode_R3E:       String = '\';
  Mode_CW:        String = ']';
  Mode_MCW:       String = '^';

  Test_Alarm:     String = 'a';
  Stop_Alarm:     String = 'b';
  Send_Alarm:     String = 'c';

  Store:          String = 'd';     // d + ASCII value + cr
  Scan:		      String = 'e';
  Set_Time:       String = 'f';     // 'f1234'#13 will set the time to 12:34
  Duplex:         String = 'g';

  Dimmer_Dn:      String = 'h';     // Display intensity down
  Dimmer_Up:      String = 'i';     // Display intensity up.
  TX_OnOff:       String = 'j';     // Toggle TX Enable (On/Off)
  Speaker_On:     String = 'k';     // Speaker enable
  Speaker_Off:    String = 'l';     // lower case L
  PreAmp_On:      String = 'm';     // RF Pre-Amp Enable
  PreAmp_Off:     String = 'n';     // RF Pre-Amp Disable
  Attenuator_On:  String = 'o';     // Antenna Attenuator Enable
  Attenuator_Off: String = 'p';     // Antenna Attenuator Disable
  Squelch_On:     String = 'q';     // Squelch enable
  Squelch_Off:    String = 'r';     // Squelch disable
  Duplex_On:      String = 's';     // Duplex enable
  Duplex_Off:     String = 't';     // Duplex disable
  TX_On:          String = 'u';     // Enable (turn on) Transmitter.
  TX_Off:         String = 'v';     // Disable (turn off) Transmitter.

  TuneStepProg:   string = 'w3'#13; // Programmable rate (how?)
  TuneStep1k:     String = 'w2'#13; // RX TUNE Step 1kHz
  TuneStep100:    String = 'w1'#13; // RX TUNE Step 100Hz
  TuneStep10:     String = 'w0'#13; // RX TUNE Step 10Hz

  Set_BFO:        string = 'x';     // Set BFO frequency (-30 ... +30, 100 Hz units)
  AF_GainSet:     String = 'y';     // 'y..'#13
                                    //   .. = 00 = maximum (!! LOUD !!)
                                    //   .. = 99 = minimum

  Dimmer_Set:     string = 'z';     // 'z.'#13
                                    //   . = 0 = display off
                                    //   . = 5 = display maximum

  EQTXRX:         string = ':;'#13; // Copy RX frequency to TX

  F500k:          string = '`';     // Go to 500 kHz
  F2182k:         string = '_';     // Go to 2182 kHz
  Get_Status:     string = '*';     // Read status (S-meter, etc.)
  Read_Config:	  string = '(';     // Read configuration string

  Fill_Scan_Buf:  string = '$';     // + {<freq.rx><freq tx>}<CR>
  Adv_ScnBuf_Ptr: string = '%';     // + [RX display frequency]
  RST_ScnBuf_Ptr: string = '%'#13;  // Reset scan buffer pointer

  Set_Option_Reg: string = '{';     // + <value 0..255><ENTER>
  Set_Preset_Reg: string = '|';     // + <value 0..255><ENTER>
  Set_Guard_Reg:  string = '}';     // + <value 0..255><ENTER>

  Exec_AST:       string = '200'#13;  // Automatically stepped self test
  Exec_MST:       string = '201'#13;  // Manually stepped self test
  Exec_AST_Num:   string = '202'#13;  // + <test#><CR> Auto starting at test#
  Exec_MST_Num:   string = '203'#13;  // + <test#><CR> Manual starting at test#

  Read_BFO_Freq:  string = '244'#13;  // Read BFO frequency
                                      // <+-><frequency in 100Hz units>
  Store_BFO_Freq: string = '244'#13'd'#13; // Store default BFO frequency

  Read_CU_Vers:   string = '246'#13;  // + <CR>
  Read_TU_Vers:   string = '247'#13;  // + <CR>

  stSOH:            string = #$01;
  stSTX:            string = #$02;
  stETX:            string = #$03;
  stEOT:            string = #$04;
  stACK:            string = #$06;
  stBEL:            string = #$07;
  stCR:             string = #$0D;
  stDLE:            string = #$10;
  stNAK:            string = #$15;
  stCAN:            string = #$18;

  // Valid range of meter reading
  MetersRange = ['`'..'t'];

  // Valid range of status messages
  StatusRange = ['u'..'z'];

  // Filenames
  StateFileName:  string = 'LastState.dat';
  ConfigFileName: string = 'Config.dat';

  // Messages
  TXCANTTUNE:     string = 'TX can''t tune to that frequency';
  RXCANTTUNE:     string = 'RX can''t tune to that frequency';
  INVALIDSPLIT:   string = 'Can''t set that split mode';
  INVALIDCHANNEL: string = 'Invalid channel number';
  INVALIDTIME:    string = 'Invalid time';
  COMMANDFAILED:  string = 'Command failed';
  ENTERREGVALUE:  string = 'Enter register value in binary';
  ENTERTIME:      string = 'Enter time (4 digits)';
  ENTERTESTNUM:   string = 'Enter start test number';
  ENTERCHANNEL:   string = 'Enter channel number';
  CHANNELMODE:    string = 'Channel mode, state unknown';
  SCANBUFMODE:    string = 'ScanBuf mode, frequency unknown';
  NOTINTHATSTATE: string = 'Not in that state, ignored';
  NOTALLOWED:     string = 'Mode change not allowed here';
  YOUAREINTX:     string = 'Note: you are transmitting';
  INVALIDTESTNUM: string = 'Start test number invalid';
  NOREPLY:        string = 'No reply, status reading disabled';

  // Mode values
  M_USB = 1;
  M_LSB = 2;
  M_AM  = 3;
  M_R3E = 4;
  M_CW  = 5;
  M_MCW = 6;
  M_TLX = 7;
  M_500K = 8;
  M_2182K = 9;

  // Filter values
  FILTER_Default = 0;
  FILTER_WIDE = 1;
  FILTER_INTERMEDIATE = 2;
  FILTER_NARROW = 3;
  FILTER_VERYNARROW = 4;

  // AGC values
  AVC_OFF = 0;
  AVC_ON = 1;
  AVC_FAST = 2;
  AVC_SLOW = 3;

  // TX power
  LOW_POWER = 1;
  MEDIUM_POWER = 2;
  FULL_POWER = 3;

  // frequency coverage
  MINRXF = 10000;
  MAXRXF = 29999990;
  MINTXF = 1605000;
  MAXTXF = 29999900;

  // keyboard states
  POWEROFF   = 0;
  NORMAL     = 1;
  SETRXF     = 2;
  SETRXM     = 3;
  SETTXF     = 4;
  SETTXM     = 5;
  SETRXTXF   = 6;
  RCLCH      = 7;
  STOCH      = 8;
  SETTIME    = 9;
  SETBFO     = 10;
  SETWAKEUP  = 11;
  SETOR      = 12;
  SETPR      = 13;
  SETGR      = 14;
  SELFTSTA   = 15;
  SELFTSTM   = 16;
  SELFTSTFMA = 17;
  SELFTSTFMA1= 18;
  SELFTSTFMM = 19;
  SELFTSTFMM1= 20;
  FILLSCNBUF = 21;
  CHANNEL    = 22;
  SCANCH     = 23;
  SCANTUBUF  = 24;

  // keyboard commands
  CommandKeys = [' ','+','-','*','/','R','T','L','U','A','C','X','.',#13];

  // Timeouts in milliseconds
  CMDTIMEOUT = 1500*OneMillisecond;
  TUNETIMEOUT = 10000*OneMillisecond;
  TESTTIMEOUT = 15000*OneMillisecond;
  DLETIMEOUT = 15000*OneMillisecond;
  TXUPTIMEOUT = 1000*OneMillisecond;

  // Maximun number of retries in SendCommand
  MAXRETRY = 10;

Type
  TRTXState = record
    Freq_rx: longint;
    Freq_tx: longint;
    Freq_step: integer;
    BFO_freq: integer;
    Mode_RX: integer;
    Mode_TX: integer;
    Filter: integer;
    AGC: integer;
    Speaker_Enabled: boolean;
    RFamp_Enabled: boolean;
    RFAtt_Enabled: boolean;
    Squelch_Enabled: boolean;
    Sensitivity: integer;
    Volume: integer;
    TX_power: integer;
    TX_Enabled: boolean;
    Scan: boolean;
    Duplex: boolean;
    PTT_State: boolean;
    Dimmer_Level: integer;
  end;

 var
  TRP: TTRP;
  RTXState, OldRTXState: TRTXState;
  SerPort: TSerialHandle = 0;
  SerPortName: string = '/dev/ttyS0';
  SerPortSpeed: integer = 2400;
  s,t: integer;
  status: string;
  STimer1, STimer2: integer;
  RXFBuf, TXFBuf, OldRXFreq, OldTXFreq: string;
  sMode_RX: string;
  sMode_TX: string;
  KeyboardState: integer = NORMAL;
  Enable_status: boolean = FALSE;
  In_Wheel: boolean = FALSE;
  In_Repeat: boolean = FALSE;
  In_RXFreqMouseUp: boolean = FALSE;
  In_TXFreqMouseUp: boolean = FALSE;
  In_Command: boolean = FALSE;
  TXFreqModified: boolean = FALSE;
  Time_Flash: boolean = TRUE;
  Mode_Flash: boolean = TRUE;
  enough: boolean = FALSE;
  ButtonToFlashRX: TbitBtn;
  ButtonToFlashTX: TbitBtn;
  ButtonToRepeat: TbitBtn;
  tmp: longint;
  HomeDir,StateDir,ChannelsDir,ImgDir: string;
  timeout,UpdateFTXTimeout: TTime;
  ImgON, ImgOFF, ImgArrUpOFF, ImgArrUpON,
  ImgArrDnOFF, ImgArrDnON: TBitmap;
  LEDColorOFF: TCOlor = clGreen;
  LEDColorON: TCOlor = ClLime;
  sLEDColor: string = 'green';
  HaveConfig: boolean = FALSE;
  HaveState: boolean = FALSE;
  HighSWR: boolean = FALSE;
  ReducedPower: boolean = FALSE;
  ScanBuf: array[1..100, 1..2] of string;
  NextTest,AbortTest: boolean;
  n,m: integer;
  pTmp: Pchar;
  BandFileName: string;
  Last_AGC: integer;
implementation

{$R *.lfm}

{ TTRP }

//
// Auxiliary procedures & functions
//

// Adjust decimal separator in real number string
// Latest compilers do not accept anymore both separators (. and ,)
function TTRP.AdjustDecimalSeparator(s: string): string;

var i: integer;

begin
    for i := 1 to Length(s) do
        if s[i]='.' then s[i] := DefaultFormatSettings.DecimalSeparator;
    AdjustDecimalSeparator := s;
end;

// Open communications
function TTRP.OpenRemote: boolean;

begin
     	Result := SendCommand(RemoteEnable, '');
        if Result then begin
                Result := Result and SendCommand(stCAN, '');
	        Result := Result and SendCommand(stCR, '');
        	Result := Result and SendCommand(stCR, '');
	        Result := Result and SendCommand(stCR, '');
        end;
end;

// Close communications
function TTRP.CloseRemote: boolean;
begin
        CloseRemote := SendCommand(RemoteDisable, '');
end;

// Send a command to CU8000
function TTRP.SendCommand(cmd, par: string): boolean;

const
  ACK = #$06;
  NAK = #$15;
  DLE = #$10;

var resp: char = chr(0);
    tmp: string;
    retry: integer = MAXRETRY;
    i,nc: integer;
    ok: boolean;

begin
        Enable_Status := FALSE;

        tmp := cmd+par;

        if MSHOWC.Checked then Message('Command sent: '+tmp);

{$IFDEF TEST_USER_INTERFACE}
        exit(TRUE);
{$ENDIF}

        if SerPort <> 0  then begin
                for i := 1 to length(tmp) do begin
                        if M2400B.Checked then sleep(10);
                        repeat
	                	nc := SerWrite(SerPort, tmp[i], 1);
{$IFDEF DEBUG}
                                if nc <> 1 then begin
                                        Message('SerWrite returned ' + IntToStr(nc));
                                end;
{$ENDIF}
        	        	timeout := time + CMDTIMEOUT;
                	        repeat
                			nc := SerRead(SerPort, resp, 1);
{$IFDEF LINUX}
                                        sleep(1);
{$ENDIF}

{$IFDEF WINDOWS}
                                        sleep(0);
{$ENDIF}
	                	until (nc > 0) or (time > timeout);
{$IFDEF DEBUG}
                                if nc <> 1 then
                                     Message('SerRead returned ' + IntToStr(nc));
{$ENDIF}
                                case resp of
                                     ACK: ok := TRUE;
                                     NAK: begin
{$IFDEF DEBUG}
                                             Message('NAK received, retrying...');
{$ENDIF}
                                	     retry := retry - 1;
                                             ok := FALSE;
                                             sleep(100);
                                     end;
                                     DLE: begin
                                         SerWrite(SerPort, stACK[1], 1);
                                         BONOFFClick(self);
                                         ok := TRUE;
                                     end;
                                     otherwise begin
                                        if resp = chr(0) then
                                           tmp := 'nothing'
                                        else
                                           tmp := resp;
                     	        	Message('SendCommand received '+tmp);
                                        ok := FALSE;
                                     end;
                                end;

                                if (time > timeout) then begin
                                   Message('Timeout expired (CMD)');
                                   retry := retry - 1;
                      	           Message('Retry #'+inttostr(MAXRETRY-retry));
                                   ok := FALSE;
	                        end;
                        until ok or (retry = 0);

                        if retry = 0 then begin
                                Message('Retry count exceeded, giving up');
                                exit(FALSE);
                        end;
              end;
	end;
        if MStatus.Checked then Enable_status := TRUE;
        SendCommand := ok;
end;

// Get reply to command
function TTRP.GetReply(ReplyLen: integer; ReplyTimeout: extended): string ;

var stmp: string;
    buf:  char = chr(0);
    resp: char = chr(0);
    i,nc: integer;

begin
    {$IFDEF TEST_USER_INTERFACE}
    exit('........................');
    {$ENDIF}
    In_Command := TRUE;
    stmp := '';
    buf := stACK[1];
    for i := 1 to ReplyLen do begin
        while SerWrite(SerPort, buf, 1) <> 1 do;
	    timeout := time + ReplyTimeout;
        repeat
            nc := SerRead(SerPort, resp, 1);
            {$IFDEF LINUX}
            sleep(1);
            {$ENDIF}
            {$IFDEF WINDOWS}
            sleep(0);
            {$ENDIF}
        until ((nc > 0) and (resp < '`')) or (time > timeout);
        {$IFDEF TEST}
        if time > timeout then Message('Timeout in GetReply');
        {$ENDIF}
        if resp <> chr(0) then stmp := stmp + resp;
    end;
    SerWrite(SerPort, buf, 1);
    GetReply := stmp;
    In_Command := FALSE;
end;

// Set RX frequency
function TTRP.SetRXFreq: boolean;

var  f: longint;
    sf: string;

    begin
	f := RTXstate.Freq_rx div 100;
      	str(f, sf);
	while Length(sf) < 6 do sf := '0' + sf;
	SetRXFreq := SendCommand(RX_Prefix, sf + stCR);
end;

// Set RX Mode
function TTRP.SetRXMode: boolean;

begin
        SetRXMode := SendCommand(RX_Prefix, sMode_RX + stCR);
end;

// Set TX frequency
function TTRP.SetTXFreq: boolean;

var  f: longint;
    sf: string;

    begin
	f := RTXstate.Freq_tx div 100;
      	str(f, sf);
	while Length(sf) < 6 do sf := '0' + sf;
	SetTXFreq := SendCommand(TX_Prefix, sf + stCR);
end;

// Set TX Mode
function TTRP.SetTXMode: boolean;

begin
        SetTXMode := SendCommand(TX_Prefix, sMode_TX + stCR);
end;

// Set RX and TX frequency
function TTRP.SetRXTXFreq: boolean;

var  f: longint;
    sf: string;

begin
     f := RTXstate.Freq_rx div 100;
     str(f, sf);
     while Length(sf) < 6 do sf := '0' + sf;
     SetRXTXFreq := SendCommand(RX_Prefix+TX_Prefix, sf + stCR);
end;

// Display a message in MSG memo
procedure TTRP.Message(ms: string);

var p: integer;
    tmp: string;

begin
    tmp := '';
    for p := 1 to length(ms) do begin
        if ms[p] = chr(13) then
            tmp := tmp+'⏎'
        else
            tmp := tmp+ms[p];
    end;
    MSG.Lines.Add(tmp);
    Application.ProcessMessages;
end;

// Clear messages in MSG memo
procedure TTRP.MSGDblClick(Sender: TObject);
begin
        MSG.Lines.Clear;
end;

// Display RX frequency
procedure TTRP.DispRXf;

var tmp: real;
    s: string;

begin
    if RTXstate.Scan then begin
            s := 'SCAN';
    end else begin
        if RTXState.Freq_RX > 0 then begin
       	   tmp := RTXState.Freq_rx / 1000.0;
           if (RTXState.Freq_step = 10) or ((RTXState.Freq_rx mod 100) <> 0) then begin
                str(tmp:8:2,s);
           end else begin
                str(tmp:7:1,s);
                s := s + ' ';
           end;
        end else begin
        s := 'CHAN.'+IntToStr(-RTXState.Freq_RX);
        end;
    end;
    RXFreq.Caption := s;
    Application.ProcessMessages;
end;

// Display TX frequency (100 Hz steps only)
procedure TTRP.DispTXf;

var tmp: real;
    s: string;

begin
    if RTXState.Scan then begin
       s := 'SCAN';
    end else begin
        if RTXState.Freq_TX > 0 then begin
      	   tmp := (RTXState.Freq_tx div 100)*100 / 1000.0;
           str(tmp:7:1,s);
           end else begin
               s := 'CHAN.'+IntToStr(-RTXState.Freq_TX);
           end;
    end;
    TXFreq.Caption := s;
    Application.ProcessMessages;
end;

// Format BFO frequency
function TTRP.FormatBFOFreq(s: string): string;
begin
	FormatBFOFreq := copy(s,1,2)+'.'+s[3]+' kHz';
end;

// Get auto self test response
function TTRP.GetAutoSelfTestResponse: boolean;

var nc: integer;
    buf: char;
    l: string = '';

begin
    repeat
           timeout := time + TESTTIMEOUT;
           repeat
                 nc := SerRead(SerPort, buf, 1);
           until (nc > 0) or (time > timeout);
           if time > timeout then begin
              Message('Timeout waiting for ''*''');
              exit(FALSE);
           end;
           SerWrite(SerPort, stACK[1], 1);
           if (buf = '>') and (l = '') then exit(FALSE);
           if (buf in ['*','>']) then begin
              if l <> '' then begin
                 if length(l) = 2 then
                         Message('Test #'+l);
                 if length(l) >= 4 then
                         Message('Test #'+copy(l,1,2)+' Result: '+copy(l,3,2));
              end;
              l := '';
           end else l := l + buf;
     until (buf = '>');

     timeout := time + DLETIMEOUT;
     repeat
        nc := SerRead(SerPort, buf, 1);
     until (nc > 0) or (time > timeout);
     if time > timeout then begin
        Message('Timeout waiting for DLE');
        exit(FALSE);
     end;

     if buf = stDLE then GetAutoSelfTestResponse := TRUE;
end;

// Get manual self test response
function TTRP.GetManSelfTestResponse: boolean;

var i,nc: integer;
    buf: char;
    l: string = '';

begin
     repeat
           repeat
                 nc := SerRead(SerPort, buf, 1);
           until (nc > 0);
           SerWrite(SerPort, stACK[1], 1);
           if buf = '*' then begin
              l := '';
	      for i := 1 to 4 do begin
                  repeat
                        nc := SerRead(SerPort, buf, 1);
                  until nc > 0;
                  if buf = '>' then break;
                  l := l + buf;
                  SerWrite(SerPort, stACK[1], 1);
              end;
           end;
           if l <> '' then Message('Test #'+copy(l,1,2)+' Result: '+copy(l,3,2));
           NextTest := FALSE;
           AbortTest := FALSE;
           repeat
                  Application.ProcessMessages;
           until NextTest or AbortTest;
     until (buf = '>') or AbortTest;

     if AbortTest then begin
        repeat
              nc := SerRead(SerPort, buf, 1);
        until nc > 0;
//        BONOFFClick(self)
     end;

     if buf = '>' then GetManSelfTestResponse := TRUE;
end;

// Keyboard handler
procedure TTRP.KeyboardHandler(keyp: string);

var f: double;
    len: integer;

begin
    len := length(RxFBuf);
    case KeyboardState of
        SETRXF: begin
                if RxFBuf <> '' then f := StrToFloat(RXFBuf+keyp) else f := 0;
        	if f*100 <= MAXRXF then RXFBuf := RXFBuf + keyp;
                RXfreq.Caption := FloatToStrF(StrToFloat(RXFBuf)/10,ffFixed,5,1)+' ';
        end;

        SETTXF: begin
                if TxFBuf <> '' then f := StrToFloat(TXFBuf+keyp) else f := 0;
        	if f*100 <= MAXTXF then TXFBuf := TXFBuf + keyp;
                TXfreq.Caption := FloatToStrF(StrToFloat(TXFBuf)/10,ffFixed,5,1);
        end;

        SETRXTXF: begin
                if RxFBuf <> '' then f := StrToFloat(RXFBuf+keyp) else f := 0;
        	if f*100 <= MAXRXF then RXFBuf := RXFBuf + keyp;
                TXfreq.Caption := FloatToStrF(StrToFloat(RXFBuf)/10,ffFixed,5,1);
                RXfreq.Caption := TXFreq.Caption + ' ';
        end;

        STOCH,RCLCH: begin
                case len of
                        0: RXFBuf := RXFBuf + keyp;
                        1: begin
                        	if (RXFBuf[1] in ['0'..'6']) or
                                   ((RXfbuf[1] = '7') and (keyp[1] in ['0'..'5'])) then
                                           RXfBuf := RXFBuf + keyp;
                        end;
                end;
                RXfreq.Caption := RXFBuf;
        end;

        SETTIME,SETWAKEUP: begin
                len := length(TXFBuf);
                case len of
                        0: if (keyp[1] in ['0'..'2']) then TXFBuf := TXFBuf + keyp;
                        1: if (TXFbuf[1] in ['0'..'1']) or
                              ((TXFBuf[1] = '2') and(keyp[1] in ['0'..'3'])) then
                                      TXFBuf := TXFBuf + keyp;
                        2: if (keyp[1] in ['0'..'5']) then TXFBuf := TXFBuf + keyp;
                        3: TXFBuf := TXFBuf + keyp;
                end;
                TXfreq.Caption := TXFBuf;
        end;

        SETBFO: begin
                case len of
                    0: begin
                            if keyp[1] in ['+','-'] then RXFBuf := RXFBuf + keyp;
                            if keyp[1] in ['0'..'3'] then begin
                                   RXFBUF := '+'+keyp;
                                   BMINUS.Visible := FALSE;
                                   BENTER.Width := 124;
                            end;
                    end;
                    1: if keyp[1] in ['0'..'3'] then begin
                           RXFBuf := RXFBuf + keyp;
                           BMINUS.Visible := FALSE;
                           BENTER.Width := 124;
                    end;
                    2: if (RxFBuf[2] in ['0'..'2']) or
                          ((RXFBuf[2] = '3') and (keyp = '0')) then RXFBuf := RXFBuf + keyp;
                end;
                if length(RXFBuf) > 1 then begin
                        RXfreq.Caption := FloatToStrF(StrToFloat(RXFBuf)/10,ffFixed,5,1)+' ';
                        if StrToFloat(RXFBuf) >= 0 then RXfreq.Caption := RXFBuf[1]+RXfreq.Caption;
                end else
                        RXfreq.Caption := RXFBuf;
        end;

        FILLSCNBUF: begin
                if m = 1 then begin
                   if RxFBuf <> '' then f := StrToFloat(RXFBuf+keyp) else f := 0;
        	   if f*100 <= MAXRXF then RXFBuf := RXFBuf + keyp;
                   RXfreq.Caption := FloatToStrF(StrToFloat(RXFBuf)/10,ffFixed,5,1)+' ';
                   exit;
                end else begin
                   if TxFBuf <> '' then f := StrToFloat(TXFBuf+keyp) else f := 0;
               	   if f <= MAXTXF then TXFBuf := TXFBuf + keyp;
                   TXfreq.Caption := FloatToStrF(StrToFloat(TXFBuf)/10,ffFixed,5,1);
                   exit;
                end;
        end;

        SETOR,SETPR,SETGR: begin
               if (len < 8) and (keyp[1] in ['0'..'1']) then begin
                      RXFBuf := RXFBuf + keyp;
                      RXFreq.Caption := RXFBuf;
               end;

        end;
        SELFTSTFMA,SELFTSTFMM: begin
               case len of
                   0: if keyp[1] in ['0'..'4'] then RXFBuf := RXFBuf+keyp;
                   1: if (RXFBuf[1] in ['0'..'3']) or
                         ((RXFBuf[1] = '4') and (keyp[1] in ['0'..'1']))
                         then RXFBuf := RXFBuf + keyp;
               end;
               RXFreq.Caption := RXFBuf;
        end;
    end;
end;

// Save config to disk
procedure TTRP.SaveConfig;

var ConfigFile: Text;

begin
     AssignFile(ConfigFile, HomeDir+ConfigFileName);
     {$I-}
     Rewrite(ConfigFile);
     {$I+}
     if IOResult = 0 then begin
	     WriteLn(ConfigFile, SerPortName);
            Writeln(ConfigFile, SerPortSpeed);

            if MStatus.Checked then
                WriteLn(ConfigFile,'TRUE')
            else
                WriteLn(ConfigFile, 'FALSE');

            if MDEFU.Checked then
                WriteLn(ConfigFile,'1')
            else if MIMMU.Checked then
                WriteLn(ConfigFile, '2')
            else
                WriteLn(ConfigFile, '0');

            if MENALL.Checked then
                WriteLn(ConfigFile,'TRUE')
            else
                WriteLn(ConfigFile, 'FALSE');
            if MSHOWC.Checked then
                WriteLn(ConfigFile,'TRUE')
            else
                WriteLn(ConfigFile, 'FALSE');
            if MALWLP.Checked then
                WriteLn(ConfigFile,'TRUE')
            else
                WriteLn(ConfigFile, 'FALSE');
            if MUSEUTC.Checked then
                WriteLn(ConfigFile,'TRUE')
            else
                WriteLn(ConfigFile,'FALSE');
             WriteLn(ConfigFile,sLEDColor);
             CloseFile(ConfigFile);
     end;
end;

// Read config from disk
procedure TTRP.ReadConfig;

var ConfigFile: Text;
    s: string;

begin
     AssignFile(ConfigFile, HomeDir+ConfigFileName);
     {$I-}
     Reset(ConfigFile);
     {$I+}
     if IOResult = 0 then begin
	     ReadLn(ConfigFile, SerPortName);
             ReadLn(ConfigFile, SerPortSpeed);
             ReadLn(ConfigFile,s);
             MStatus.Checked := (s = 'TRUE');
             ReadLn(ConfigFile,s);
             case s of
                  '1': MDEFU.Checked := TRUE;
                  '2': MIMMU.Checked := TRUE;
                  otherwise MDISU.Checked := TRUE;
             end;
             ReadLn(ConfigFile,s);
             MENALL.Checked := (s = 'TRUE');
             ReadLn(ConfigFile,s);
             MSHOWC.Checked := (s = 'TRUE');
             ReadLn(ConfigFile,s);
             MALWLP.Checked := (s = 'TRUE');
             ReadLn(ConfigFile,s);
             MUSEUTC.Checked := (s = 'TRUE');

             ReadLn(ConfigFile,sLEDColor);
             if sLEDColor = 'red' then begin
                     LEDColorOFF := clMaroon;
                     LEDColorON := clRed;
                     MRed.Checked := TRUE;
                     MGreen.Checked := FALSE;
                     MYellow.Checked := FALSE;
             end;
             if sLEDColor = 'green' then begin
                     LEDColorOFF := clGreen;
                     LEDColorON := clLime;
                     MRed.Checked := FALSE;
                     MGreen.Checked := TRUE;
                     MYellow.Checked := FALSE;
             end;
             if sLEDColor = 'yellow' then begin
                     LEDColorOFF := clOlive;
                     LEDColorON := clYellow;
                     MRed.Checked := FALSE;
                     MGreen.Checked := FALSE;
                     MYellow.Checked := TRUE;
             end;
             CloseFile(ConfigFile);
     end else begin
             // default values
{$IFDEF LINUX}
             SerPortName := '/dev/ttyS0';
{$ENDIF}

{$IFDEF WINDOWS}
        SerPortName := 'COM1';
{$ENDIF}
             SerPortSpeed := 2400;
             MStatus.Checked := FALSE;
             MDEFU.Checked := TRUE;
             LEDColorOFF := ClYellow;
             LEDColorON := clYellow;
             sLEDColor := 'yellow';
             MYellow.Checked := TRUE;
             MRed.Checked := FALSE;
             MGreen.Checked := FALSE;
     end;
{$IFDEF LINUX}
        if SerPortName = '/dev/ttyS0' then begin
{$ENDIF}

{$IFDEF WINDOWS}
        if SerPortName = 'COM1' then begin
{$ENDIF}
	     Mttys0.Checked := TRUE;
             Mttys1.Checked := FALSE;
             MCustom.Checked := FALSE;
     end else begin
{$IFDEF LINUX}
             if SerPortName = '/dev/ttyS1' then begin
{$ENDIF}
{$IFDEF WINDOWS}
             if SerPortName = 'COM2' then begin
{$ENDIF}
             Mttys0.Checked := FALSE;
             Mttys1.Checked := TRUE;
             MCustom.Checked := FALSE;
     	end else begin
             Mttys0.Checked := FALSE;
             Mttys1.Checked := FALSE;
             MCustom.Checked := TRUE;
     	end;
     end;

     if SerPortSpeed = 300 then begin
          M300B.Checked := TRUE;
          M2400B.Checked := FALSE;
     end else begin
             M300B.Checked := FALSE;
             M2400B.Checked := TRUE;
     end;
     HaveConfig := TRUE;
end;

// Save last state to disk
procedure TTRP.SaveLastState;

var StateFile: FILE of TRTXState;

begin
     AssignFile(StateFile, HomeDir+StateFileName);
     {$I-}
     Rewrite(StateFile);
     {$I+}
     if IOResult = 0 then begin
	     Write(StateFile, RTXState);
	     CloseFile(StateFile);
     end;
end;

// Set default state
procedure TTRP.SetDefaultState;
begin
     with RTXstate do begin
          Freq_rx := 14200000;
          Freq_tx := 14200000;
	  Freq_step := 1000;
	  BFO_freq := 800;
	  Mode_RX := M_USB;
          Mode_TX := M_USB;
	  Filter := FILTER_DEFAULT;
	  AGC := AVC_SLOW;
	  Speaker_Enabled := TRUE;
	  RFamp_Enabled := FALSE;
	  RFAtt_Enabled := FALSE;
	  Squelch_Enabled := FALSE;
	  Sensitivity := 0;
	  Volume := 80;
	  TX_power := FULL_POWER;
	  TX_Enabled := TRUE;
	  PTT_state := FALSE;
          Scan := FALSE;
          Duplex := FALSE;
          Dimmer_Level := 5;
     end;

end;

// Read last autosaved state from disk or set default state
procedure TTRP.LoadLastState;

var StateFile: FILE of TRTXState;

    begin
	AssignFile(StateFile, HomeDir+StateFileName);
        {$I-}
        Reset(StateFile);
        {$I+}
        if IOResult = 0 then begin
        	Read(StateFile, RTXState);
                CloseFile(StateFile);
        end else begin
	        // Default values if no last state file found
                SetDefaultState;
        end;
        OldRTXState := RTXState;
        Last_AGC := RTXState.AGC;
        HaveState := TRUE;
end;

//Create ordered Channels submenus
procedure TTRP.LoadChannelsDir;

var m: TMenuItem;
    n: integer;
    Info: TSearchRec;
    FileList: TStringList;

begin
     FileList := TStringList.Create;
     FileList.Sorted := TRUE;
     if FindFirst(ChannelsDir+'*.dat', faAnyFile, info) = 0 then begin
        repeat
              delete(Info.Name, Length(Info.Name)-3, 4);
              FileList.Add(Info.Name);
        until FindNext(Info) <> 0;
        FindClose(Info);
        MChannels.Clear;
        for n := 0 to FileList.Count-1 do begin
            m := TmenuItem.Create(MChannels);
            m.Caption := FileList.Strings[n];
            m.OnClick := @LoadChannel;
            MChannels.Add(m);
        end;
        FileList.Clear;
        FileList.Free;
     end else begin
         MChannels.Clear;
         m := TmenuItem.Create(MChannels);
         m.Caption := 'No channels defined';
         MChannels.Add(m);
     end;
end;

// Load a channel file
procedure TTRP.LoadChannel(Sender: TObject);

var BandFile: FILE of TRTXState;

begin
     AssignFile(BandFile,ChannelsDir+(Sender as TMenuItem).Caption+'.dat');
     {$I-}
     Reset(BandFile);
     {$I+}
     if IOResult = 0 then begin
        Read(BandFile,RTXState);
        CloseFile(BandFile);
     end else Message('Can''t open band file');
     RestoreState;
     UpdatePanel;
end;

// Disable all controls except ON/OFF and some menus
procedure TTRP.DisableAllControls;

var i: integer;

begin
     for i := 0 to ComponentCount - 1 do begin
         if Components[i] is TControl then begin
	    TControl(Components[i]).Enabled := FALSE;
	 end;
         if Components[i] is TShape then begin
            TShape(Components[i]).Brush.Color := clDefault;
            TShape(Components[i]).Enabled := FALSE;
	 end;
     end;
     MLState.Enabled := FALSE;
     MSState.Enabled := FALSE;
     MSChann.Enabled := FALSE;
     MOtFun.Enabled := FALSE;
     MStatus.Enabled := FALSE;
     MTrans.Enabled := FALSE;
     MChannels.Enabled := FALSE;
     BONOFF.Enabled := TRUE;
     FLASH.Enabled := FALSE;
     RXFreq.Enabled := TRUE;
     TXFreq.Enabled := TRUE;
end;

// Disable all buttons
procedure TTRP.DisableAllButtons;

var i: integer;

begin
     for i := 0 to ComponentCount - 1 do begin
         if Components[i] is TBitBtn then
	    TBitBtn(Components[i]).Enabled := FALSE;
	 if Components[i] is TButton then
	    TButton(Components[i]).Enabled := FALSE;
     end;
end;

// Enable all controls
procedure TTRP.EnableAllControls;

var i: integer;

begin
     if KeyboardState = POWEROFF then exit;

     for i := 0 to ComponentCount - 1 do begin
	if Components[i] is TControl then begin
  	   TControl(Components[i]).Enabled := TRUE;
        end;
       	if Components[i] is TMenuItem then begin
           TMenuItem(Components[i]).Enabled := TRUE;
	end;
       	if Components[i] is TShape then begin
           TShape(Components[i]).Enabled := TRUE;
	end;
    end;
    FLASH.Enabled := TRUE;
    BMINUS.Visible := FALSE;
    if MSTATUS.Checked then begin
       SM.Enabled := TRUE;
       TSTATUS.Enabled := TRUE;
    end;
end;

// Set all annunciators off
procedure TTRP.SetAllLEDsOff;
begin
     BUSB.Glyph := ImgOFF;
     BLSB.Glyph := ImgOFF;
     BAM.Glyph  := ImgOFF;
     BTELEX.Glyph := ImgOFF;
     BR3E.Glyph := ImgOFF;
     BCW.Glyph := ImgOFF;
     BMCW.Glyph := ImgOFF;
     BLOW.Glyph := ImgOFF;
     BMED.Glyph := ImgOFF;
     BFULL.Glyph := ImgOFF;
     BDUP.Glyph := ImgOFF;
     BSCAN.Glyph := ImgOFF;
     BWIDE.Glyph := ImgOFF;
     BINTER.Glyph := ImgOFF;
     BNAR.Glyph := ImgOFF;
     BVNAR.Glyph := ImgOFF;
     BSPKR.Glyph := ImgOFF;
     BRFAMP.Glyph := ImgOFF;
     BRFATT.Glyph := ImgOFF;
     BSQL.Glyph := ImgOFF;
     BAGCON.Glyph := ImgOFF;
     BAGCFAST.Glyph := ImgOFF;
     BAGCSLOW.Glyph := ImgOFF;
     BAGCOFF.Glyph := ImgOFF;
     BVOLDN.Glyph := ImgArrDnOFF;
     BVOLUP.Glyph := ImgArrUpOFF;
end;

// Set active/not active buttons state
procedure TTRP.SetActiveButtons;
begin
     if MENALL.Checked then
        // Do not try to disable inactive buttons, so do nothing and return
        exit
     else begin
        if (RTXstate.Freq_rx < 0) or RTXstate.Scan then begin
            DisableAllButtons;
            If RTXState.Scan then BENTER.Enabled := TRUE;
            Application.ProcessMessages;
            exit;
        end;
        if RTXState.TX_Enabled then
           BTRANS.Enabled := TRUE
        else
            BTRANS.Enabled := FALSE;

        case RTXState.Mode_RX of
            M_USB,M_LSB,M_R3E: begin
                BWIDE.Enabled := FALSE;
                BINTER.Enabled := TRUE;
         		BNAR.Enabled := FALSE;
         		BVNAR.Enabled := FALSE;
               	BBFODN.Enabled := FALSE;
               	BBFOUP.Enabled := FALSE;
                BAGCON.Enabled := TRUE;
                BAGCFAST.Enabled := TRUE;
               	BAGCSLOW.Enabled := TRUE;
               	BAGCOFF.Enabled := TRUE;
                if RTXState.TX_Enabled then BTRANS.Enabled := TRUE;
         	end;
            M_CW: begin
                BWIDE.Enabled := TRUE;
         		BINTER.Enabled := TRUE;
         		BNAR.Enabled := TRUE;
         		BVNAR.Enabled := TRUE;
               	BBFODN.Enabled := TRUE;
               	BBFOUP.Enabled := TRUE;
                BAGCON.Enabled := TRUE;
                BAGCFAST.Enabled := TRUE;
               	BAGCSLOW.Enabled := TRUE;
               	BAGCOFF.Enabled := TRUE;
                BTRANS.Enabled := FALSE;
            end;
            M_MCW: begin
                BWIDE.Enabled := TRUE;
         		BINTER.Enabled := TRUE;
         		BNAR.Enabled := TRUE;
         		BVNAR.Enabled := TRUE;
               	BBFODN.Enabled := FALSE;
               	BBFOUP.Enabled := FALSE;
                BAGCON.Enabled := TRUE;
                BAGCFAST.Enabled := TRUE;
               	BAGCSLOW.Enabled := TRUE;
               	BAGCOFF.Enabled := TRUE;
                BTRANS.Enabled := FALSE;
            end;
            M_AM: begin
                BWIDE.Enabled := TRUE;
                BINTER.Enabled := FALSE;
         		BNAR.Enabled := FALSE;
         		BVNAR.Enabled := FALSE;
               	BBFODN.Enabled := FALSE;
               	BBFOUP.Enabled := FALSE;
                BAGCON.Enabled := TRUE;
                BAGCFAST.Enabled := TRUE;
               	BAGCSLOW.Enabled := FALSE;
               	BAGCOFF.Enabled := TRUE;
                if RTXState.TX_Enabled then BTRANS.Enabled := TRUE;
            end;
            M_TLX: begin
                BWIDE.Enabled := FALSE;
                BINTER.Enabled := FALSE;
         		BNAR.Enabled := FALSE;
         		BVNAR.Enabled := FALSE;
               	BBFODN.Enabled := FALSE;
               	BBFOUP.Enabled := FALSE;
                BAGCON.Enabled := TRUE;
                BAGCFAST.Enabled := TRUE;
               	BAGCSLOW.Enabled := FALSE;
             	BAGCOFF.Enabled := FALSE;
                if RTXState.TX_Enabled then BTRANS.Enabled := TRUE;
            end;
        end;

        case RTXState.AGC of
            AVC_ON, AVC_FAST, AVC_SLOW: begin
			    BSENSDN.Enabled := FALSE;
                BSENSUP.Enabled := FALSE;
            end;
            AVC_OFF: begin
			    BSENSDN.Enabled := TRUE;
               	BSENSUP.Enabled := TRUE;
            end;
        end;

        case KeyboardState of
            NORMAL: begin
                B0.Enabled := FALSE;
                B1.Enabled := FALSE;
                B2.Enabled := FALSE;
                B3.Enabled := FALSE;
                B4.Enabled := FALSE;
                B5.Enabled := FALSE;
                B6.Enabled := FALSE;
                B7.Enabled := FALSE;
                B8.Enabled := FALSE;
                B9.Enabled := FALSE;
                BENTER.Enabled := FALSE;
            end;
            SELFTSTA: begin
                DisableAllButtons;
            end;
            SELFTSTM: begin
                DisableAllButtons;
                BENTER.Enabled := TRUE;
                BDIMUP.Enabled := TRUE;
                BDIMDN.Enabled := TRUE;
            end;
            SELFTSTFMA: begin
                DisableAllButtons;
                B0.Enabled := TRUE;
                B1.Enabled := TRUE;
                B2.Enabled := TRUE;
                B3.Enabled := TRUE;
                B4.Enabled := TRUE;
                B5.Enabled := TRUE;
                B6.Enabled := TRUE;
                B7.Enabled := TRUE;
                B8.Enabled := TRUE;
                B9.Enabled := TRUE;
                BENTER.Enabled := TRUE;
            end;
            SELFTSTFMA1: begin
                DisableAllButtons;
            end;
            SELFTSTFMM: begin
                DisableAllButtons;
                B0.Enabled := TRUE;
                B1.Enabled := TRUE;
                B2.Enabled := TRUE;
                B3.Enabled := TRUE;
                B4.Enabled := TRUE;
                B5.Enabled := TRUE;
                B6.Enabled := TRUE;
                B7.Enabled := TRUE;
                B8.Enabled := TRUE;
                B9.Enabled := TRUE;
                BDIMUP.Enabled := TRUE;
                BDIMDN.Enabled := TRUE;
                BENTER.Enabled := TRUE;
            end;
            SELFTSTFMM1: begin
                DisableAllButtons;
                BDIMUP.Enabled := TRUE;
                BDIMDN.Enabled := TRUE;
                BENTER.Enabled := TRUE;
            end;
            SCANCH: begin
                DisableAllButtons;
                BENTER.Enabled := TRUE;
                BSCAN.Enabled := TRUE;
            end;
            otherwise begin
                B0.Enabled := TRUE;
                B1.Enabled := TRUE;
                B2.Enabled := TRUE;
                B3.Enabled := TRUE;
                B4.Enabled := TRUE;
                B5.Enabled := TRUE;
                B6.Enabled := TRUE;
                B7.Enabled := TRUE;
                B8.Enabled := TRUE;
                B9.Enabled := TRUE;
                BENTER.Enabled := TRUE;
            end;
        end;
     end;
end;

// Update indicators state
procedure TTRP.UpdatePanel;

var tmp_mode: integer;

begin
        // If channel mode or in off state, disable all buttons and exit
        if (RTXState.Freq_RX < 0) or (KeyboardState = POWEROFF) then begin
            SetActiveButtons;
            exit;
        end;

	// Frequency step
    	case RTXState.Freq_step of
            10: begin
                STEP10H.Brush.Color := LEDColorON;
                STEP100H.Brush.Color := LEDCOlorOFF;
                STEP1K.Brush.Color := LEDColorOFF;
            end;
            100: begin
                STEP10H.Brush.Color := LEDColorOFF;
                STEP100H.Brush.Color := LEDColorON;
                STEP1K.Brush.Color := LEDColorOFF;
            end;
            1000: begin
                STEP10H.Brush.Color := LEDColorOFF;
                STEP100H.Brush.Color := LEDColorOFF;
                STEP1K.Brush.Color := LEDColorON;
            end;
        end;

        // Meters
        if Mstatus.Checked then begin
            Enable_Status := TRUE;
            Tstatus.Enabled := TRUE;
            SMETER.Visible := TRUE;
       	    WMETER.Visible := TRUE;
            STSIG.Visible := TRUE;
            STPWR.Visible := TRUE;
        end else begin;
       	    Tstatus.Enabled := FALSE;
            Enable_Status := FALSE;
            SMETER.Visible := FALSE;
     	    WMETER.Visible := FALSE;
            STSIG.Visible := FALSE;
            STPWR.Visible := FALSE;
        end;

        // Filter
        case RTXState.Filter of
            FILTER_DEFAULT: begin
                BWIDE.Glyph := ImgOFF;
                BINTER.Glyph := ImgOFF;
                BNAR.Glyph := ImgOFF;
                BVNAR.Glyph := ImgOFF;
            end;
            FILTER_WIDE: begin
                BWIDE.Glyph := ImgON;
                BINTER.Glyph := ImgOFF;
                BNAR.Glyph := ImgOFF;
                BVNAR.Glyph := ImgOFF;
            end;
            FILTER_INTERMEDIATE: begin
                BWIDE.Glyph := ImgOFF;
                BINTER.Glyph := ImgON;
                BNAR.Glyph := ImgOFF;
                BVNAR.Glyph := ImgOFF;
            end;
            FILTER_NARROW: begin
                BWIDE.Glyph := ImgOFF;
                BINTER.Glyph := ImgOFF;
                BNAR.Glyph := ImgON;
                BVNAR.Glyph := ImgOFF;
            end;
            FILTER_VERYNARROW: begin
                BWIDE.Glyph := ImgOFF;
                BINTER.Glyph := ImgOFF;
                BNAR.Glyph := ImgOFF;
                BVNAR.Glyph := ImgON;
            end;
        end;

        // SPEAKER
        if RTXState.Speaker_Enabled then
        	BSPKR.Glyph := ImgON
        else
        	BSPKR.Glyph := ImgOFF;

        // RF AMPLIFIER
        if RTXState.RFamp_Enabled then
            BRFAMP.Glyph := ImgON
        else
        	BRFAMP.Glyph := ImgOFF;

        // RF ATTENUATOR
        if RTXState.RFatt_Enabled then
        	BRFATT.Glyph := ImgON
        else
        	BRFATT.Glyph := ImgOFF;

        // SQUELCH
        if RTXState.Squelch_Enabled then
        	BSQL.Glyph := ImgON
        else
        	BSQL.Glyph := ImgOFF;

        // AGC
        case RTXState.AGC of
            AVC_ON: begin
                if not RTXState.PTT_State then begin
                    BAGCON.Glyph := ImgON;
                    BAGCSLOW.Glyph := ImgOFF;
                    BAGCFAST.Glyph := ImgOFF;
                    BAGCOFF.Glyph := ImgOFF;
                end;
            end;

            AVC_FAST: begin
                if not RTXState.PTT_State then begin
                    BAGCON.Glyph := ImgON;
                    BAGCSLOW.Glyph := ImgOFF;
                    BAGCFAST.Glyph := ImgON;
                    BAGCOFF.Glyph := ImgOFF;
                end;
            end;

            AVC_SLOW: begin
                if not RTXState.PTT_State then begin
                    BAGCON.Glyph := ImgON;
                    BAGCSLOW.Glyph := ImgON;
                    BAGCFAST.Glyph := ImgOFF;
                    BAGCOFF.Glyph := ImgOFF;
                end;
            end;

            AVC_OFF: begin
                if not RTXState.PTT_State then begin
                    BAGCON.Glyph := ImgOFF;
                    BAGCSLOW.Glyph := ImgOFF;
                    BAGCFAST.Glyph := ImgOFF;
                    BAGCOFF.Glyph := ImgON;
                end;
            end;
        end;

        // Update split mode flashing
        if RTXState.Mode_RX <> RTXState.Mode_TX then begin
            case RTXState.Mode_RX of
                M_USB: ButtonToFlashTX := BUSB;
                M_LSB: ButtonToFlashTX := BLSB;
                M_AM:  ButtonToFlashTX := BAM;
                M_R3E: ButtonToFlashTX := BR3E;
            end;
            case RTXState.Mode_TX of
                M_USB: ButtonToFlashRX := BUSB;
                M_LSB: ButtonToFlashRX := BLSB;
                M_AM:  ButtonToFlashRX := BAM;
                M_R3E: ButtonToFlashRX := BR3E;
            end;
            FLASH.Enabled := TRUE;
        end else begin
            FLASH.Enabled := FALSE;
            if RTXState.PTT_State then begin
                if ButtonToFlashTX <> nil then
                    ButtonToFlashTX.Glyph := ImgON;
                end else begin
                    if ButtonToFlashRX <> nil then
                        ButtonToFlashRX.Glyph := ImgON;
                end;
                ButtonToFlashRX := nil;
                ButtonToFlashTX := nil;
        end;

        // MODE
        if RTXState.PTT_State then begin
            tmp_mode := RTXState.Mode_TX;
        end else begin
            tmp_mode := RTXState.Mode_RX;
        end;
        case tmp_mode of
      	    M_LSB: begin
			    BLSB.Glyph := ImgON;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph := ImgOFF;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorOFF;
            end;
		    M_USB: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgON;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph := ImgOFF;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorOFF;
            end;
		    M_AM: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgON;
                BTELEX.Glyph := ImgOFF;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorOFF;
            end;
		    M_TLX: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph := ImgON;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorOFF;
            end;
		    M_CW: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph := ImgOFF;
			    BCW.Glyph := ImgON;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorOFF;
            end;
		    M_MCW: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph := ImgOFF;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgON;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorOFF;
  		    end;
		    M_R3E: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph := ImgOFF;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgON;
                SCUR.Brush.Color := LEDColorOFF;
      	    end;
		    M_500K: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph := ImgOFF;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorON;
            end;
		    M_2182K: begin
			    BLSB.Glyph := ImgOFF;
			    BUSB.Glyph := ImgOFF;
			    BAM.Glyph := ImgOFF;
                BTELEX.Glyph  := ImgOFF;
			    BCW.Glyph := ImgOFF;
                BMCW.Glyph := ImgOFF;
			    BR3E.Glyph := ImgOFF;
                SCUR.Brush.Color := LEDColorON;
            end;
        end;

        //Power
        case RTXState.TX_power of
            LOW_POWER: begin
                BLOW.Glyph := ImgON;
                BMED.Glyph := ImgOFF;
                BFULL.Glyph := ImgOFF;
            end;
            MEDIUM_POWER: begin
                BLOW.Glyph := ImgOFF;
                BMED.Glyph := ImgON;
                BFULL.Glyph := ImgOFF;
            end;
            FULL_POWER: begin
                BLOW.Glyph := ImgOFF;
                BMED.Glyph := ImgOFF;
                BFULL.Glyph := ImgON;
            end;
        end;

        // TX ON/OFF & TX frequency display (clock when TX disabled)
        if RTXState.TX_Enabled then begin
            Clock.Enabled := FALSE;
            BTXONOFF.Caption := 'TX OFF';
            BTRANS.Enabled := TRUE;
        end else begin
            Clock.Enabled := TRUE;
            BTRANS.Enabled := FALSE;
            BTXONOFF.Caption := 'TX ON';
        end;

        // RX/TX
        if RTXState.TX_Enabled then begin
            BTRANS.Enabled := TRUE;
        	if RTXState.PTT_State then begin
                BTRANS.Caption := 'Receive';
            end else begin
	            BTRANS.Caption := 'Transmit';
            end;
        end else BTRANS.Enabled := FALSE;

        // Scan
        if RTXState.Scan then begin
            BSCAN.Glyph := ImgON;
        end else begin
            BSCAN.Glyph := ImgOFF;
        end;

        // Duplex (?)
        if RTXState.Duplex then begin
            BDUP.Glyph := ImgON;
        end else begin
            BDUP.Glyph := ImgOFF;
        end;

        // Disable/enable TX LEDS
        if MStatus.Checked then begin
            SPLOW.Visible := TRUE;
            SCUR.Visible := TRUE;
            SRPWR.Visible := TRUE;
            STRP1.Visible := TRUE;
            STRP2.Visible := TRUE;
        end else begin
            SPLOW.Visible := FALSE;
            SCUR.Visible := FALSE;
            SRPWR.Visible := FALSE;
            STRP1.Visible := FALSE;
            STRP2.Visible := FALSE;
        end;

        // LEDs
        if HighSWR then
            // Must flash this
            SPLOW.Brush.Color := LEDColorOff
        else
            SPLOW.Brush.Color := LEDColorOn;

        if ReducedPower then
            SRPWR.Brush.Color := LEDColorOn
        else
            SRPWR.Brush.Color := LEDColorOFF;

        // Set active buttons according to RTXState and KeyboardState
        SetActiveButtons;
end;

// Restore state in RTXState
procedure TTRP.RestoreState;

var cmd: string;

begin
    In_Command := TRUE;

    //Set and show frequencies
    RTXState.Freq_RX := 100*(RTXState.Freq_RX div 100);
    DispRXf;
    DispTXf;

    // If channel mode, set and display channel number and exit
    if RTXState.Freq_RX < 0 then begin
        KeyboardState := CHANNEL;
        if not SendCommand(Recall, IntToStr(-RTXState.Freq_RX)) then
            Message(COMMANDFAILED);
        DispRXf;
        DispTXf;
        KeyboardState := CHANNEL;
        SetAllLEDsOff;
        exit;
    end else KeyboardState := NORMAL;

    // Set RX and TX frequency
    if RTXState.Freq_rx = RTXState.Freq_tx then begin
        if not SetRXTXfreq then
            Message(COMMANDFAILED);
    end else begin
        // Set RX frequency
        if not SetRXFreq then
            Message(COMMANDFAILED);

        // Set TX frequency
	    if not SetTXFreq then
            Message(COMMANDFAILED);
    end;

    // Set frequency step
    case RTXState.Freq_step of
        10: cmd := TuneStep10;
        100: cmd := TuneStep100;
        1000: cmd := TuneStep1k;
        otherwise begin
            // Invalid value, default to 1 kHz
            RTXState.Freq_step := 1000;
            cmd := TuneStep1K;
        end;
    end;
    if not SendCommand(cmd, '') then
        Message(COMMANDFAILED);

    // Set BFO
    if not SendCommand(Set_BFO, IntToStr(RTXState.BFO_freq div 100)+stCR) then
        Message(COMMANDFAILED);

    // Set mode
    case RTXState.Mode_RX of
        M_USB: cmd := Mode_USB;
        M_LSB: cmd := Mode_LSB;
        M_AM: cmd := Mode_AM;
        M_R3E: cmd := Mode_R3E;
        M_CW: cmd := Mode_CW;
        M_MCW: cmd := Mode_MCW;
        M_TLX: cmd := Mode_Telex;
        M_2182k: cmd := Mode_AM;
        M_500k: cmd := Mode_MCW;
        otherwise begin
            // Invalid value, default to USB
            RTXState.Mode_RX := M_USB;
            cmd := Mode_USB;
        end;
    end;
    if not SendCommand(cmd, '') then
        Message(COMMANDFAILED);

    if RTXState.Mode_TX <> RTXState.Mode_RX then begin
        case RTXState.Mode_TX of
            M_USB: cmd := Mode_USB;
                M_LSB: cmd := Mode_LSB;
                M_AM:  cmd := Mode_AM;
                M_R3E: cmd := Mode_R3E;
                M_CW:  cmd := Mode_CW;
                M_MCW: cmd := Mode_MCW;
                M_TLX: cmd := Mode_Telex;
            otherwise begin
                // Invalid value, default to USB
                RTXState.Mode_TX := M_USB;
                cmd := Mode_USB;
            end;
        end;
        if not SendCommand(TX_Prefix, cmd + stCR) then
            Message(COMMANDFAILED);
    end;

    // Set filter
    case RTXState.Filter of
        FILTER_WIDE: cmd := Filt_Wide;
        FILTER_INTERMEDIATE: cmd := Filt_Inter;
        FILTER_NARROW:  cmd := Filt_Narrow;
        FILTER_VERYNARROW: cmd := Filt_VNarrow;
        otherwise begin
            // Invalid value, use default filter
            RTXState.Filter := FILTER_DEFAULT;
            cmd := '';
        end;
    end;
    if cmd <> '' then if not SendCommand(cmd, '') then
        Message(COMMANDFAILED);

    // Set AGC
    case RTXState.AGC of
        AVC_ON: cmd := AGC_On;
        AVC_OFF: cmd := AGC_Off;
        AVC_FAST: cmd := AGC_Fast;
        AVC_SLOW: cmd := AGC_Slow;
        otherwise begin
            // Invalid value, default to SLOW
            RTXState.AGC := AVC_SLOW;
            cmd := AGC_SLOW;
        end;
    end;
    if not SendCommand(cmd, '') then
        Message(COMMANDFAILED);
    if RTXSTate.AGC <> AVC_OFF then

    // Set volume
    if not SendCommand(AF_GainSet,IntToStr(RTXState.Volume)+stCR) then
        Message(COMMANDFAILED);

    // Set Antenna attenuator
    if RTXState.RFAtt_Enabled then begin
        if not SendCommand(Attenuator_On,'') then Message(COMMANDFAILED);
    end else begin
        if not SendCommand(Attenuator_Off,'') then Message(COMMANDFAILED);
    end;

    // Set RF preamp
    if RTXState.RFAmp_Enabled then begin
        if not SendCommand(Preamp_On,'') then Message(COMMANDFAILED);
    end else begin
        if not SendCommand(Preamp_Off,'') then Message(COMMANDFAILED);
    end;

    //Set speaker
    if RTXState.Speaker_Enabled then begin
        if not SendCommand(Speaker_On, '') then Message(COMMANDFAILED)
    end else begin
        if not SendCommand(Speaker_Off, '') then Message(COMMANDFAILED);
    end;

    // Set squelch
    if RTXState.Squelch_Enabled then begin
        if not SendCommand(Squelch_On, '') then Message(COMMANDFAILED)
    end else begin
        if not SendCommand(Squelch_Off, '') then Message(COMMANDFAILED);
    end;

    // Set TX ON/OFF
    if RTXState.TX_Enabled then begin
        if not SendCommand(TX_On, '') then Message(COMMANDFAILED);
    end else begin
        if not SendCommand(TX_Off, '') then Message(COMMANDFAILED);
    end;

    // Set power
    if MALWLP.Checked then RTXState.TX_power := LOW_POWER;
    case RTXState.TX_power of
        LOW_POWER: cmd := TX_LowPwr;
        MEDIUM_POWER: cmd := TX_MediumPwr;
        FULL_POWER: cmd := TX_HighPwr;
        otherwise begin
            // Invalid value, default to full power
            RTXState.TX_Power := FULL_POWER;
            cmd := TX_HighPwr;
        end;
    end;
    if not SendCommand(cmd, '') then Message(COMMANDFAILED);

    // Set dimmer
    if not (RTXState.Dimmer_Level in [0..5]) then RTXState.Dimmer_Level := 5;
    if not SendCommand(Dimmer_Set, IntToStr(RTXState.Dimmer_Level) + stCR) then
        Message(COMMANDFAILED);

    // Status polling
    if MStatus.Checked then begin
        TStatus.Enabled := TRUE;
        SMETER.Visible := TRUE;
        WMETER.Visible := TRUE;
    end else begin
        TStatus.Enabled := FALSE;
        SMETER.Visible := FALSE;
        WMETER.Visible := FALSE;
    end;

    // Scan mode
    if RTXState.Scan then begin
        KeyBoardState := SCANCH;
        if not SendCommand(Scan+Scan, '') then
            Message(CommandFailed);
    end;
    In_Command := FALSE;
end;

//
// Object init & functions
//

// Various initializations at startup
procedure TTRP.FormCreate(Sender: TObject);

begin

    {$IFDEF TEST_USER_INTERFACE}
    TRP.Caption := 'TRP8255 Control - USER INTERFACE TEST MODE!';
    {$ENDIF}
    RXfreq.Caption := '';
    TXfreq.Caption := '';
    DisableAllControls;
    BONOFF.Enabled := TRUE;
    KeyboardState := POWEROFF;

    // Read config
    ReadConfig;

    // Read button on/off bitmaps
    ImgOFF := TBitmap.Create;
    ImgON := TBitmap.Create;
    ImgArrUpOFF := TBitmap.Create;
    ImgArrUpON := TBitmap.Create;
    ImgArrDnOFF := TBitmap.Create;
    ImgArrDnON := TBitmap.Create;

    ImgOFF.LoadFromFile(ImgDir+'off-'+sLEDColor+'.bmp');
    ImgON.LoadFromFile(ImgDir+'on-'+sLEDCOlor+'.bmp');
    ImgArrUpOFF.LoadFromFile(ImgDir+'arrow-up-off-'+sLEDColor+'.bmp');
    ImgArrUpON.LoadFromFile(ImgDir+'arrow-up-on-'+sLEDCOlor+'.bmp');
    ImgArrDnOFF.LoadFromFile(ImgDir+'arrow-down-off-'+sLEDColor+'.bmp');
    ImgArrDnON.LoadFromFile(ImgDir+'arrow-down-on-'+sLEDCOlor+'.bmp');

    ImgON.Mask(clWhite);
    ImgOFF.Mask(clWhite);
    ImgArrUpOFF.Mask(clWhite);
    ImgArrUpON.Mask(clWhite);
    ImgArrDnOFF.Mask(clWhite);
    ImgArrDnON.Mask(clWhite);

    // Initialize button flash & repeat storage
    ButtonToFlashRX := TBitBtn.Create(self);
    ButtonToFlashTX := TBitBtn.Create(self);
    ButtonToRepeat := TBitBtn.Create(self);

    // Initialize bitmaps
    SetAllLEDsOff;

    // Set colors
    RXFreq.Font.Color := LEDColorON;
    TXFreq.Font.Color := LEDColorON;

    {$IFDEF LINUX}
    // Button captions requiring two lines
    BAGCON.Caption := 'AGC'+LineEnding+' ON';
    BAGCFAST.Caption := 'AGC'+LineEnding+'FAST';
    BAGCSLOW.Caption := ' AGC'+LineEnding+'SLOW';
    BAGCOFF.Caption := 'AGC'+LineEnding+'OFF';
    BSETT.Caption := ' SET'+LineEnding+'TIME';
    BDUP.Caption := ' DU'+LineEnding+'PLEX';
    BRATE.Caption := 'TUNE'+LineEnding+'RATE';
    BVNAR.Caption := 'VERY'+LineEnding+'NARR';
    BRFAMP.Caption := ' RF'+LineEnding+'AMP';
    BRFATT.Caption := 'ANT'+LineEnding+'ATT';
    BSQL.Caption := ' SQU'+LineEnding+'ELCH';
    BSPKR.Caption := ' SPE'+LineEnding+'AKER';
    BLOW.Caption := 'LOW'+LineEnding+'PWR';
    BMED.Caption := 'MED'+LineEnding+'PWR';
    BFULL.Caption := 'FULL'+LineEnding+'PWR';

    // TBitBtn one-line captions
    BUSB.Caption := BUSB.Caption+LineEnding;
    BLSB.Caption := BLSB.Caption+LineEnding;
    BAM.Caption := BAM.Caption+LineEnding;
    BTELEX.Caption := BTELEX.Caption+LineEnding;
    BR3E.Caption := BR3E.Caption+LineEnding;
    BCW.Caption := BCW.Caption+LineEnding;
    BMCW.Caption := BMCW.Caption+LineEnding;
    BSCAN.Caption := BSCAN.Caption+LineEnding;
    BWIDE.Caption := BWIDE.Caption+LineEnding;
    BINTER.Caption := BINTER.Caption+LineEnding;
    BNAR.Caption := BNAR.Caption+LineEnding;
    {$ENDIF}
    // Read channels directory
    LoadChannelsDir;

    {$IFDEF WINDOWS}
    Mttys0.Caption := 'COM1';
    Mttys1.Caption := 'COM2';
    {$ENDIF}

end;

// Close down program
procedure TTRP.CloseProgram;
begin
    if MStatus.Checked then begin
        TStatus.Enabled := FALSE;
 	    Enable_Status := FALSE;
    end;
    if SerPort > 0 then begin
       CloseRemote;
       SerFlush(SerPort);
       SerClose(SerPort);
    end;
    if HaveConfig then SaveConfig;
    if HaveState then SaveLastState;

    ImgOFF.Destroy;
    ImgON.Destroy;
    ImgArrUpOFF.Destroy;
    ImgArrUpON.Destroy;
    ImgArrDnOFF.Destroy;
    ImgArrDnON.Destroy;
    if ButtonToFlashRX <> nil then ButtonToFlashRX.Destroy;
    if ButtonToFlashTX <> nil then ButtonToFlashTX.Destroy;
    if ButtonToRepeat <> nil then ButtonToRepeat.Destroy;

    Halt;
end;

procedure TTRP.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
    CloseAction := caNone;
    MexitClick(Sender);
end;

// Allows to enter frequency and some commands using the keyboard
procedure TTRP.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

var keyp: char;

begin
    case Key of
        VK_NUMPAD0..VK_NUMPAD9: keyp := chr(key-48);
        VK_DECIMAL: keyp := '.';
        VK_DIVIDE: keyp := '/';
        VK_ADD,VK_UP: keyp := '+';
        VK_SUBTRACT,VK_DOWN: keyp := '-';
        VK_MULTIPLY: keyp := '*';
        VK_DELETE: keyp := chr(8);
        otherwise begin
            keyp := UpCase(chr(key));
            if not (keyp in CommandKeys) then exit;
        end;
    end;
    {$IFDEF TEST}
    Message('key down: '+IntToStr(key)+' ('+keyp+')');
    {$ENDIF}

    keyp := UpCase(keyp);
    if KeyboardState <> NORMAL then begin
        if (KeyboardState = SETRXF) or (KeyboardState = SETTXF) then begin
           case keyp of
               'R': BRXClick(Sender);
               'T': BTXClick(Sender);
               'U': BUSBClick(Sender);
               'L': BLSBClick(Sender);
               'A': BAMClick(Sender);
               'C': BCWClick(Sender);
               'M': BMCWClick(Sender);
               'E': BR3ECLick(Sender);
               'X': BTELEXClick(Sender);
           end;
        end;

        if KeyboardState = SETBFO then begin
            if keyp in ['+','-'] then KeyboardHandler(Keyp);
        end;
        if (Keyp = chr(13)) and BENTER.Enabled then begin
            {$IFDEF WINDOWS}
            BENTER.SetFocus;
            {$ENDIF}
            BEnterClick(BENTER);
        end;
         if keyp = chr(8) then begin
            case KeyboardState of
                SETRXF,STOCH,RCLCH: begin
                    RXFreq.Caption := '_';
                    RXFBuf := '';
                end;
                SETTXF,SETTIME,SETWAKEUP: begin
                    TXFreq.Caption := '_';
                    RXFBuf := '';
                end;
                SETRXTXF: begin
                    RXFreq.Caption := '_';
                    RXFBuf := '';
                    TXFreq.Caption := '_';
                    RXFBuf := '';
                end;
            end;
        end;
        if keyp in ['0'..'9'] then KeyboardHandler(Keyp);
    end else begin
        case keyp of
            ' ': if BTRANS.Enabled then BTRANSClick(Sender);
            '+': BTUNEUPClick(Sender);
            '-': BTUNEDNClick(Sender);
            '/': BRATEClick(Sender);
            '*': BTUNEClick(Sender);
            'R': BRXCLick(Sender);
            'T': BTXClick(Sender);
            'U': BUSBClick(Sender);
            'L': BLSBClick(Sender);
            'A': BAMClick(Sender);
            'C': BCWClick(Sender);
            'M': BMCWClick(Sender);
            'E': BR3ECLick(Sender);
            'X': BTELEXClick(Sender);
            '.': begin
                case RTXState.TX_power of
                    LOW_POWER   : BMEDCLick(Sender);
                    MEDIUM_POWER: BFULLClick(Sender);
                    FULL_POWER  : BLOWClick(Sender);
                end;
            end;
        end;
    end;
    Key := 0;
end;

procedure TTRP.FormResize(Sender: TObject);
begin
    TRP.Width := 767;
    TRP.height := 599;
end;

//
// Menu handling
//

// "File" menu handling

// "Load state"
procedure TTRP.MLSTATEClick(Sender: TObject);

var StateFile: FILE of TRTXState;

begin
    OpenDialog1.InitialDir := StateDir;
    If OpenDialog1.Execute then begin
        AssignFile(StateFile,OpenDialog1.Filename);
        {$I-}
        Reset(StateFile);
        {$I+}
        if IOResult = 0 then begin
            Read(StateFile,RTXState);
            CloseFile(StateFile);
        end else Message('Can''t open file');
            RestoreState;
            UpdatePanel;
        end;
end;

// "Save state"
procedure TTRP.MSSTATEClick(Sender: TObject);

var StateFile: file of TRTXState;
    SModeRX: string = '';
    SModeTX: string = '';
    sMtmp,sFtmp: string;

begin
    case RTXState.Mode_RX of
        M_USB: SModeRX := 'USB';
            M_LSB: SModeRX := 'LSB';
            M_AM:  SmodeRX := 'AM';
            M_TLX: SModeRX := 'TELEX';
            M_R3E: SModeRX := 'R3E';
            M_CW:  SModeRX := 'CW';
            M_MCW: SModeRX := 'MCW';
            M_2182K: SModeRX := '2182';
            M_500K: SModeRX := '500';
        end;

        sMtmp := sModeRX;

        if RTXState.Mode_TX <> RTXState.Mode_RX then begin
            case RTXState.Mode_TX of
                M_USB: SModeTX := 'USB';
                M_LSB: SModeTX := 'LSB';
                M_AM:  SmodeTX := 'AM';
                M_TLX: SModeTX := 'TELEX';
                M_R3E: SModeTX := 'R3E';
                M_CW:  SModeTX := 'CW';
                M_MCW: SModeTX := 'MCW';
                M_2182K: SModeTX := '2182';
                M_500K: SModeTX := '500';
            end;
            sMtmp := sModeRX+'-'+sModeTX;
        end;

        if RTXState.TX_Enabled then begin
            if RTXstate.Freq_tx <> RTXstate.Freq_rx then
                sFtmp := Trim(RXFreq.Caption) + '-' + Trim(TXFreq.Caption)
           else
                sFtmp := Trim(RXFreq.Caption);
        end else begin
            sFtmp := Trim(RXFreq.Caption)+'-TXOFF';
        end;

        if RTXState.Freq_RX < 0 then begin
            sMtmp := '';
            sFtmp := RXFreq.Caption;
        end;

        if Sender = MSSTATE then SaveDialog1.InitialDir := StateDir;
        if Sender = MSCHANN then SaveDialog1.InitialDir := ChannelsDir;
        SaveDialog1.FileName := sFtmp + '-' + sMtmp + '.dat';
        If SaveDialog1.Execute then begin
            AssignFile(StateFile,SaveDialog1.Filename);
            {$I-}
            Rewrite(StateFile);
            {$I+}
            if IOResult = 0 then begin
                Write(StateFile,RTXState);
                CloseFile(StateFile);
            end;
        end;
        if Sender = MSCHANN then MRELCHClick(Sender);
end;


// "Exit"
procedure TTRP.MExitClick(Sender: TObject);
begin
    if Application.Messagebox('Really exit?',
       'Close program', MB_YESNO+MB_ICONSTOP) = IDYES then
        CloseProgram;
    end;

//
// "Other functions" menu handling
//

// "Read configuration"
procedure TTRP.MRCONFClick(Sender: TObject);

var nc:  integer;
    buf: char =chr(0);
    resp: string = '';
begin
    if SendCommand(Read_Config, '') then begin
        timeout := time + CMDTIMEOUT;
        repeat
	        nc := SerRead(SerPort, buf, 1);
	    until ((nc > 0) and (buf = '*')) or (time > timeout);
        if time > timeout then begin
            Message('Timeout waiting for ''*''');
            exit;
        end;
        repeat
	        SerWrite(SerPort, stACK[1], 1);
	        repeat
        	    nc := SerRead(SerPort, buf, 1);
		    until (nc > 0);
        	    if buf <> '>' then resp := resp + buf;
	        until buf = '>';
	      	SerWrite(SerPort, stACK[1], 1);
	        Message('Configuration: '+ resp);
	end else Message(COMMANDFAILED);
end;

// "Read CU version"
procedure TTRP.MRCUClick(Sender: TObject);

begin
    if SendCommand(Read_CU_Vers, '') then begin
	    Message('CU ' + Copy(GetReply(13,CMDTIMEOUT),2,11));
        // sleep(500);
        if not SendCommand(stCR, '') then Message(COMMANDFAILED);
	    RestoreState;
	    UpdatePanel;
    end else Message(COMMANDFAILED);
end;

// "Read TU version"
procedure TTRP.MRTUClick(Sender: TObject);
begin
    if SendCommand(Read_TU_Vers, '') then begin
	    Message('TU ' + Copy(GetReply(13,CMDTIMEOUT),2,11));
        // sleep(500);
	    if not SendCommand(stCR, '') then Message(COMMANDFAILED);
	        RestoreState;
	        UpdatePanel;
        end else Message(COMMANDFAILED);
end;

// "Read BFO frequency"
procedure TTRP.MRBFOClick(Sender: TObject);

var s: string;

begin
    if SendCommand(Read_BFO_Freq, '') then begin
	s := GetReply(3,CMDTIMEOUT);
	Message('BFO = ' + FormatBFOFreq(s));
    // sleep(500);
	if not SendCommand(stCR, '') then Message(COMMANDFAILED);
	    RestoreState;
	    UpdatePanel;
    end else Message(COMMANDFAILED);
end;

// "Set BFO frequency"
procedure TTRP.MSETBFOClick(Sender: TObject);
begin
    BENTER.Width := 92;
    BMINUS.Visible := TRUE;
    RXFreq.Caption := '';
    RXFBuf := '';
    KeyboardState := SETBFO;
    Message('Enter BFO frequency in kHz');
    SetActiveButtons;
end;

// Store BFO frequency
procedure TTRP.MSTOBFOClick(Sender: TObject);

var s: string;

begin
    if not SendCommand(Store_BFO_Freq, '') then
        Message(COMMANDFAILED)
    else begin
        s := GetReply(3,CMDTIMEOUT);
        SendCommand(stCR, '');
        Message('BFO frequency stored ('+FormatBFOFreq(s)+')');
    end;
end;

// "Test alarm"
procedure TTRP.MTSTALRMClick(Sender: TObject);
begin
    if not SendCommand(Test_Alarm, '') then
        Message(COMMANDFAILED)
    else
        Message('Test alarm started');
end;

// "Stop alarm"
procedure TTRP.MSTPALRMClick(Sender: TObject);
begin
    if not SendCommand(Stop_Alarm, '') then
        Message(COMMANDFAILED)
    else
        Message('Alarm stopped');
end;

// "Send alarm"
procedure TTRP.MSNDALRMClick(Sender: TObject);
begin
    if Application.MessageBox('Are you sure?',
        'SEND ALARM', MB_YESNO+MB_ICONSTOP) = IDYES then begin
        if not SendCommand(Send_Alarm, '') then
            Message(COMMANDFAILED)
        else
            Message('SENDING ALARM!');
    end;
end;

// "Set guard register"
procedure TTRP.MSETGRClick(Sender: TObject);
begin
    OldRXFreq := RXFreq.Caption;
    RXFreq.Caption := '';
    RXFBuf := '';
    KeyboardState := SETGR;
    Message(ENTERREGVALUE);
    SetActiveButtons;
end;

// "Set option register"
procedure TTRP.MSETORClick(Sender: TObject);
begin
    OldRXFreq := RXFreq.Caption;
    RXFreq.Caption := '';
    RXFBuf := '';
    KeyboardState := SETOR;
    Message(ENTERREGVALUE);
    SetActiveButtons;
end;

// "Set preset register"
procedure TTRP.MSETPRClick(Sender: TObject);
begin
    OldRXFreq := RXFreq.Caption;
    RXFreq.Caption := '';
    RXFBuf := '';
    KeyboardState := SETPR;
    Message(ENTERREGVALUE);
    SetActiveButtons;
end;

// "Fill TU8000 scan buffer"
procedure TTRP.MFILLBUFClick(Sender: TObject);
begin
    Message('Enter one or more frequency pair');
    OldRXFreq := RXFreq.Caption;
    RXFreq.Caption := '_';
    RXFBuf := '';
    OldTXFreq := TXFreq.Caption;
    TXFreq.Caption := '';
    TXFBuf := '';
    n := 1;
    m := 1;
    KeyboardState := FILLSCNBUF;
    SetActiveButtons;
end;

// "Advance scan buffer pointer"
procedure TTRP.MADVSCPTRClick(Sender: TObject);
begin
    if SendCommand(Adv_ScnBuf_Ptr, '') then begin
        RXFreq.Caption := 'SCAN_TU';
        TXFreq.Caption := RXFreq.Caption;
     	KeyboardState := SCANTUBUF;
        Message(SCANBUFMODE);
     end else
     	Message(COMMANDFAILED);
end;

// "Reset scan buffer pointer"
procedure TTRP.MRSTSCBPClick(Sender: TObject);
begin
    if not SendCommand(RST_ScnBuf_Ptr, '') then
        Message(COMMANDFAILED);
end;

// "Self test (auto)"
procedure TTRP.MTESTAUTOClick(Sender: TObject);

begin
    TStatus.Enabled := FALSE;
    SM.Enabled := FALSE;
    if SendCommand(Exec_AST,'') then begin
        KeyboardState := SELFTSTA;
        SetActiveButtons;
        if GetAutoSelfTestResponse then begin
            BONOFFClick(Sender);
            sleep(2000);
            BONOFFClick(Sender);
        end else
            KeyboardState := NORMAL;
    end;
end;

// "Self test (manual)"
procedure TTRP.MTESTMANClick(Sender: TObject);
begin
    TStatus.Enabled := FALSE;
    SM.Enabled := FALSE;
    Message('WARNING: NO TIMEOUTS!');
    DisableAllButtons;
    if SendCommand(Exec_MST,'') then begin
        KeyboardState := SELFTSTM;
        SetActiveButtons;
        if GetManSelfTestResponse then
            BONOFFClick(Sender)
        else KeyboardState := NORMAL;
    end;
end;

// "Self test from... (auto)"
procedure TTRP.MTESTFMAUTOClick(Sender: TObject);
begin
    TStatus.Enabled := FALSE;
    SM.Enabled := FALSE;
    Message('WARNING: NO TIMEOUTS!');
    OldRXfreq := RXFreq.Caption;
    RXFreq.Caption := '';
    RXFBuf := '';
    KeyboardState := SELFTSTFMA;
    Message(ENTERTESTNUM);
    SetActiveButtons;
end;

// "Self test from... (manual)"
procedure TTRP.MTESTFMMANClick(Sender: TObject);
begin
	TStatus.Enabled := FALSE;
    SM.Enabled := FALSE;
    Message('WARNING: NO TIMEOUTS!');
    DisableAllButtons;
    OldRXfreq := RXFreq.Caption;
    RXFreq.Caption := '';
    RXFBuf := '';
    KeyboardState := SELFTSTFMM;
    Message(ENTERTESTNUM);
    SetActiveButtons;
end;

// "Release remote priority"
procedure TTRP.MRELPRIOClick(Sender: TObject);
begin
    if SendCommand(stEOT,'') then
        Message('Remote priority released')
    else
        Message(COMMANDFAILED);
end;

// "Reset RTX"
procedure TTRP.MRESETClick(Sender: TObject);
begin
    TStatus.Enabled := FALSE;
	if SendCommand(RTX_RESET, '') then begin
	    Message('Reset done');
    end else Message(COMMANDFAILED);
    SerFlush(SerPort);
    SerClose(SerPort);
    SerPort := 0;
    BONOFF.Caption := 'SUPPLY ON';
    RXFreq.Caption := '';
    TXFreq.Caption := '';
    DisableAllControls;
end;

// "Restore current state"
procedure TTRP.MRSTATEClick(Sender: TObject);
begin
    RestoreState;
    EnableAllControls;
    SetActiveButtons;
    UpdatePanel;
end;

// "Exit channel mode"
procedure TTRP.MEXITCHANClick(Sender: TObject);
begin
    case KeyboardState of
        CHANNEL: begin
  		    KeyboardState := NORMAL;
            RTXState := OldRTXState;
            RestoreState;
            UpdatePanel;
        end;
        SCANCH,SCANTUBUF: begin
      	    KeyboardState := NORMAL;
            RestoreState;
            UpdatePanel;
        end;
        otherwise Message(NOTINTHATSTATE);
    end;
    EnableAllControls;
    SetActiveButtons;
    UpdatePanel;
end;

//
// "Options" menu handling
//

// "RS232 port"

// "ttyS0"
procedure TTRP.Mttys0Click(Sender: TObject);
begin
    {$IFDEF LINUX}
    SerPortName := '/dev/ttyS0';
    {$ENDIF}

    {$IFDEF WINDOWS}
    SerPortName := 'COM1';
    {$ENDIF}

    SaveConfig;
end;

// "ttyS1"
procedure TTRP.Mttys1Click(Sender: TObject);
begin
    {$IFDEF LINUX}
    SerPortName := '/dev/ttyS1';
    {$ENDIF}

    {$IFDEF WINDOWS}
    SerPortName := 'COM2';
    {$ENDIF}
    SaveConfig;
end;

// "Custom..."
procedure TTRP.MCustomClick(Sender: TObject);
begin
    FSerport.Show;
    FSerport.Eser.Text := SerPortName;
end;

// "RS232 speed"

// "300 baud"
procedure TTRP.M300BClick(Sender: TObject);
begin
    M300B.Checked := TRUE;
    M2400B.Checked := FALSE;
    SerPortSpeed := 300;
    SaveConfig;
end;

// "2400 baud"
procedure TTRP.M2400BClick(Sender: TObject);
begin
    SerPortSpeed := 2400;
    SaveConfig;
end;

// "Status reading"
procedure TTRP.MStatusClick(Sender: TObject);
begin
    MStatus. Checked := not MStatus.Checked;
    if Mstatus.Checked then begin
        if SerPortSpeed < 2400 then begin
            Message('Serial speed too slow, status reading disabled');
            MStatus.Checked := FALSE;
        end else begin
            SM.Enabled := TRUE;
            TSTATUS.Enabled := TRUE;
            Enable_Status := TRUE;
        end;
    end else begin
        SM.Enabled := FALSE;
        TSTATUS.Enabled := FALSE;
        Enable_Status := FALSE;
    end;
    SaveConfig;
    UpdatePanel;
end;

// "Transceiver"

// "Disabled"
procedure TTRP.MDISUClick(Sender: TObject);
begin
  // Nothing to do
end;

// "Deferred update"
procedure TTRP.MDEFUClick(Sender: TObject);
begin
    RTXState.Freq_tx := RTXState.Freq_rx;
    if not SetTXFreq then Message(COMMANDFAILED);
    DispTXf;
    SaveConfig;
end;

// "Immediate update"
procedure TTRP.MIMMUClick(Sender: TObject);
begin
    RTXState.Freq_tx := RTXState.Freq_rx;
    if not SetTXFreq then Message(COMMANDFAILED);
    DispTXf;
    SaveConfig;
end;

// "Always start in LP mode"
procedure TTRP.MALWLPClick(Sender: TObject);
begin
    MALWLP.Checked := not MALWLP.Checked;
end;

// "LED Color"

// "Green"
procedure TTRP.MGreenClick(Sender: TObject);
begin
    LEDCOlorOFF := clGreen;
    LEDColorON := clLime;
    sLEDColor := 'green';
    RXFreq.Font.Color := LEDColorON;
    TXFreq.Font.Color := LEDColorON;
    ImgOFF.LoadFromFile(ImgDir+'off-'+sLEDColor+'.bmp');
    ImgON.LoadFromFile(ImgDir+'on-'+sLEDColor+'.bmp');
    ImgArrUpOFF.LoadFromFile(ImgDir+'arrow-up-off-'+sLEDColor+'.bmp');
    ImgArrUpON.LoadFromFile(ImgDir+'arrow-up-on-'+sLEDCOlor+'.bmp');
    ImgArrDnOFF.LoadFromFile(ImgDir+'arrow-down-off-'+sLEDColor+'.bmp');
    ImgArrDnON.LoadFromFile(ImgDir+'arrow-down-on-'+sLEDCOlor+'.bmp');
    if RTXState.Volume < 99 then
        BVOLDN.Glyph := ImgArrDnOFF
    else
        BVOLDN.Glyph := ImgArrDnON;
    if RTXState.Volume > 0 then
        BVOLUP.Glyph := ImgArrUpOFF
    else
        BVOLUP.Glyph := ImgArrUpON;
    SaveConfig;
    UpdatePanel;
end;

// "Yellow"
procedure TTRP.MYellowClick(Sender: TObject);
begin
    LEDCOlorOFF := clOlive;
    LEDColorON := clYellow;
    sLEDColor := 'yellow';
    RXFreq.Font.Color := LEDColorON;
    TXFreq.Font.Color := LEDColorON;
    ImgOFF.LoadFromFile(ImgDir+'off-'+sLEDColor+'.bmp');
    ImgON.LoadFromFile(ImgDir+'on-'+sLEDColor+'.bmp');
    ImgArrUpOFF.LoadFromFile(ImgDir+'arrow-up-off-'+sLEDColor+'.bmp');
    ImgArrUpON.LoadFromFile(ImgDir+'arrow-up-on-'+sLEDCOlor+'.bmp');
    ImgArrDnOFF.LoadFromFile(ImgDir+'arrow-down-off-'+sLEDColor+'.bmp');
    ImgArrDnON.LoadFromFile(ImgDir+'arrow-down-on-'+sLEDCOlor+'.bmp');
    if RTXState.Volume < 99 then
        BVOLDN.Glyph := ImgArrDnOFF
    else
        BVOLDN.Glyph := ImgArrDnON;
    if RTXState.Volume > 0 then
        BVOLUP.Glyph := ImgArrUpOFF
    else
        BVOLUP.Glyph := ImgArrUpON;
    SaveConfig;
    UpdatePanel;
end;

// "Red"
procedure TTRP.MRedClick(Sender: TObject);
begin
    LEDCOlorOFF := clMaroon;
    LEDColorON := clRed;
    sLEDColor := 'red';
    RXFreq.Font.Color := LEDColorON;
    TXFreq.Font.Color := LEDColorON;
    ImgOFF.LoadFromFile(ImgDir+'off-'+sLEDColor+'.bmp');
    ImgON.LoadFromFile(ImgDir+'on-'+sLEDColor+'.bmp');
    ImgArrUpOFF.LoadFromFile(ImgDir+'arrow-up-off-'+sLEDColor+'.bmp');
    ImgArrUpON.LoadFromFile(ImgDir+'arrow-up-on-'+sLEDCOlor+'.bmp');
    ImgArrDnOFF.LoadFromFile(ImgDir+'arrow-down-off-'+sLEDColor+'.bmp');
    ImgArrDnON.LoadFromFile(ImgDir+'arrow-down-on-'+sLEDCOlor+'.bmp');
    if RTXState.Volume < 99 then
        BVOLDN.Glyph := ImgArrDnOFF
    else
        BVOLDN.Glyph := ImgArrDnON;
    if RTXState.Volume > 0 then
        BVOLUP.Glyph := ImgArrUpOFF
    else
        BVOLUP.Glyph := ImgArrUpON;
    SaveConfig;
    UpdatePanel;
end;

// "Enable all controls"
procedure TTRP.MENALLClick(Sender: TObject);
begin
    MENALL.Checked := not MENALL.Checked;
    if MENALL.Checked then EnableAllControls;
    SaveConfig;
    UpdatePanel;
end;

procedure TTRP.MUSEUTCClick(Sender: TObject);
begin
    MUSEUTC.Checked := not MUSEUTC.Checked;
end;

procedure TTRP.MMANCHClick(Sender: TObject);
begin
    UMGR.Caption := 'Channel Manager';
    UMGR.TFLB.Directory := ChannelsDir;
    UMGR.TFLB.UpdateFileList;
    UMGR.Tag := 1;
    UMGR.Show;
end;

procedure TTRP.MMANSTClick(Sender: TObject);
begin
    UMGR.Caption := 'State Manager';
    UMGR.TFLB.Directory := StateDir;
    UMGR.TFLB.UpdateFileList;
    UMGR.Tag := 0;
    UMGR.Show;
end;

procedure TTRP.MRELCHClick(Sender: TObject);
begin
    LoadChannelsDir;
end;

// Show commands
procedure TTRP.MSHOWCClick(Sender: TObject);
begin
    MSHOWC.Checked := not MSHOWC.Checked;
    SaveConfig;
end;

//
// "Help" menu handling
//

// "About"
procedure TTRP.MABOUTClick(Sender: TObject);
begin
    FAbout.Show;
end;

// "Manual"
procedure TTRP.MMANClick(Sender: TObject);
begin
    FMAN.Show;
end;

// "GNU License"
procedure TTRP.MGNULICClick(Sender: TObject);
begin
    FGNU.Show;
end;

//
// Buttons handling (left block row 1: main tuning)
//

// TUNE down
procedure TTRP.BTUNEDNClick(Sender: TObject);

begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    if RTXState.Freq_rx-RTXState.Freq_step >= MINRXF then begin
        if SendCommand(Tune_Dn,'') then begin
       	    RTXState.Freq_rx := RTXState.Freq_rx - RTXState.Freq_step;
       		DispRXf;
	       	if MIMMU.Checked then begin
                if RTXState.Freq_rx-RTXState.Freq_step >= MINTXF then begin
       	            RTXState.Freq_tx := RTXState.Freq_rx;
               	    if not SetTXFreq then Message(COMMANDFAILED);
                    DispTXf;
                end else begin
                    Message(TXCANTTUNE);
                end;
            end;
        end else Message(COMMANDFAILED);
	end;
    UpdateFTXTimeout := time+TXUPTIMEOUT;
    TXFReqModified := FALSE;
    In_Command := FALSE;
end;


procedure TTRP.BTUNEDNMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    ButtonToRepeat := BTUNEDN;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BTUNEDNMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    In_Command := FALSE;
end;

// Step select
procedure TTRP.BRATEClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    case RTXState.Freq_step of
        10: begin
            if SendCommand(TuneStep100,'') then
                RTXState.Freq_step := 100
            else
                Message(COMMANDFAILED);
       	end;

        100: begin
            if SendCommand(TuneStep1k,'') then
                RTXState.Freq_step := 1000
            else
                Message(COMMANDFAILED);
        end;

        1000: begin
            if SendCommand(TuneStep10,'') then
                RTXState.Freq_step := 10
            else
                Message(COMMANDFAILED);
       	end;
        otherwise begin
            if SendCommand(TuneStep1k,'') then
                RTXState.Freq_step := 1000
            else
                Message(COMMANDFAILED);
        end;
    end;
    UpdatePanel;
    DispRXf;
    In_Command := FALSE;
end;

// TUNE up
procedure TTRP.BTUNEUPClick(Sender: TObject);

begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    if RTXState.Freq_rx+RTXState.Freq_step <= MAXRXF then begin
	    if SendCommand(Tune_Up,'') then begin
     	    RTXState.Freq_rx := RTXState.Freq_rx + RTXState.Freq_step;
	        DispRXf;
     		if MIMMU.Checked then begin
                if RTXState.Freq_rx+RTXState.Freq_step <= MAXTXF then begin
        	        RTXState.Freq_tx := RTXState.Freq_rx;
       			    if not SetTXFreq then Message(COMMANDFAILED);
                	DispTXf;
                end else begin
                    Message(TXCANTTUNE);
                end;
            end;
		end else
            Message(COMMANDFAILED);
    end;
    UpdateFTXTimeout := time+TXUPTIMEOUT;
    TXFReqModified := FALSE;
    In_Command := FALSE;
end;


procedure TTRP.BTUNEUPMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    ButtonToRepeat := BTUNEUP;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BTUNEUPMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    In_Command := FALSE;
end;

//
// Buttons handling (block 1 row 2: BFO tuning)
//

procedure TTRP.BBFODNClick(Sender: TObject);

var s: string = '';

begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    if SendCommand(BFO_Tune_Dn,'') then begin
        s := GetReply(3,CMDTIMEOUT);
        if s <> '' then begin
            Message('BFO = '+ FormatBFOFreq(s));
            RTXState.BFO_Freq := 100*StrToInt(s);
        end;
    end else Message(COMMANDFAILED);
    In_Command := FALSE;
end;

procedure TTRP.BBFODNMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    {$IFDEF BFOREPEAT}
    if (KeyboardState <> NORMAL) or In_Command then exit;

     In_Command := TRUE;
     ButtonToRepeat := BBFODN;
     {$IFDEF WINDOWS}
     RPT.Interval := 1000;
     {$ENDIF}
     {$IFDEF LINUX}
     RPT.Interval := 500;
     {$ENDIF}
     enough := FALSE;
     RPT.Enabled := TRUE;
     {$ENDIF}
end;

procedure TTRP.BBFODNMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    {$IFDEF BFOREPEAT}
    if (KeyboardState <> NORMAL) then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    In_Command := FALSE;
    {$ENDIF}
end;


procedure TTRP.BBFOUPClick(Sender: TObject);

var s: string = '';

begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    if SendCommand(BFO_Tune_Up,'') then begin
        s := GetReply(3,CMDTIMEOUT);
        if (s <> '') and (s[1] in ['+','-']) then begin
            Message('BFO = ' + FormatBFOfreq(s));
            RTXState.BFO_Freq := 100*StrToInt(s);
        end;
    end else Message(COMMANDFAILED);
    In_Command := FALSE;
end;

procedure TTRP.BBFOUPMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    {$IFDEF BFOREPEAT}
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    ButtonToRepeat := BBFOUP;
    RPT.Interval := 1000;
    {$IFDEF WINDOWS}
    RPT.Interval := 1000;
    {$ENDIF}
    {$IFDEF LINUX}
    RPT.Interval := 500;
    {$ENDIF}
    enough := FALSE;
    RPT.Enabled := TRUE;
    {$ENDIF}
end;

procedure TTRP.BBFOUPMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    {$IFDEF BFOREPEAT}
    if (KeyboardState <> NORMAL) then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    In_Command := FALSE;
    {$ENDIF}
end;

//
// Buttons handling (block 1 row 3: IF filter selection)
//

// Wide
procedure TTRP.BWIDEClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) {or In_Command} then exit;

    In_Command := TRUE;
    if SendCommand(Filt_Wide,'') then begin
	    RTXState.Filter:=FILTER_WIDE;
        UpdatePanel;
    end;
    In_Command := FALSE;
end;

// Intermediate
procedure TTRP.BINTERClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    if SendCommand(Filt_Inter,'') then begin
        RTXState.Filter:=FILTER_INTERMEDIATE;
        UpdatePanel;
     end else Message(COMMANDFAILED);
     In_Command := FALSE;
end;

// Narrow
procedure TTRP.BNARClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    if SendCommand(Filt_Narrow,'') then begin
	    RTXState.Filter:=FILTER_NARROW;
        UpdatePanel;
    end else Message(COMMANDFAILED);
    In_Command := FALSE;
end;

// Very narrow
procedure TTRP.BVNARClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
	if SendCommand(Filt_Vnarrow,'') then begin
	    RTXState.Filter:=FILTER_VERYNARROW;
        UpdatePanel;
    end else
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

//
// Buttons handling (block 1 row 4: misc controls)
//

// Speaker
procedure TTRP.BSPKRClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    RTXState.Speaker_Enabled := not RTXState.Speaker_Enabled;
    if RTXState.Speaker_Enabled then begin
        if not SendCommand(Speaker_On,'') then
            Message(COMMANDFAILED);
        end else begin
            if not SendCommand(Speaker_Off,'') then
                Message(COMMANDFAILED);
        end;
        UpdatePanel;
        In_Command := FALSE;
end;

// RF preamp
procedure TTRP.BRFAMPClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    RTXState.RFamp_Enabled := not RTXState.RFAmp_Enabled;
    if RTXState.RFamp_Enabled then begin
        if not SendCommand(PreAmp_On,'') then
            Message(COMMANDFAILED);
        end else begin
            if not SendCommand(PreAmp_Off,'') then
            Message(COMMANDFAILED);
    end;
    UpdatePanel;
    In_Command := FALSE;
end;

// RF attenuator
procedure TTRP.BRFATTClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    RTXState.RFAtt_Enabled := not RTXState.RFAtt_Enabled;
    if RTXState.RFatt_Enabled then begin
        if not SendCommand(Attenuator_On,'') then
            Message(COMMANDFAILED);
    end else begin
        if not SendCommand(Attenuator_Off,'') then
        Message(COMMANDFAILED);
    end;
    UpdatePanel;
    In_Command := FALSE;
end;

// Squelch
procedure TTRP.BSQLClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    RTXState.Squelch_Enabled := not RTXState.Squelch_Enabled;
    if RTXState.Squelch_Enabled then begin
        if not SendCommand(Squelch_On,'') then
            Message(COMMANDFAILED);
    end else begin
        if not SendCommand(Squelch_Off,'') then
            Message(COMMANDFAILED);
    end;
    UpdatePanel;
    In_Command := FALSE;
end;

//
// Buttons handling (block 1 row 5: AGC)
//

// AGC ON
procedure TTRP.BAGCONClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
	if SendCommand(AGC_ON,'') then begin
        if RTXState.AGC = AVC_OFF then RTXState.AGC := Last_AGC;
        UpdatePanel;
    end else
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

// AGC FAST
procedure TTRP.BAGCFASTClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    if SendCommand(AGC_Fast,'') then begin
        RTXstate.AGC := AVC_FAST;
        Last_AGC := AVC_FAST;
        UpdatePanel;
     end else
        Message(COMMANDFAILED);
     In_Command := FALSE;
end;

//AGC SLOW
procedure TTRP.BAGCSLOWClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
	if SendCommand(AGC_Slow,'') then begin
        RTXstate.AGC := AVC_SLOW;
        Last_AGC := AVC_SLOW;
        UpdatePanel;
    end else
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

// AGC OFF
procedure TTRP.BAGCOFFClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
	if SendCommand(AGC_Off,'') then begin
        RTXstate.AGC := AVC_OFF;
        UpdatePanel;
    end else
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

//
// Buttons handling (block 1 row 6: sensitivity)
//

// Sensitivity down
procedure TTRP.BSENSDNClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    if not SendCommand(Sensitivity_Dn,'') then
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

procedure TTRP.BSENSDNMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    ButtonToRepeat := BSENSDN;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BSENSDNMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    In_Command := FALSE;
end;

// Sensitivity up
procedure TTRP.BSENSUPClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    if not SendCommand(Sensitivity_Up,'') then
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

procedure TTRP.BSENSUPMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    ButtonToRepeat := BSENSUP;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BSENSUPMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    In_Command := FALSE;
end;

//
// Buttons handling (block 1 row 7: volume)
//

// Volume down

procedure TTRP.BVOLDNClick(Sender: TObject);

var s: string;

begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    if RTXstate.Volume < 99 then begin
        inc(RTXState.Volume);
        s := IntToStr(RTXState.Volume);
        if length(s) < 2 then s := '0'+s;
        if not SendCommand(AF_GainSet, s+stCR) then
            Message(COMMANDFAILED)
        else
            Message('Volume attenuation: '+IntToStr(RTXState.Volume));
    end;
    UpdatePanel;
    In_Command := FALSE;
end;

procedure TTRP.BVOLDNMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    BVOLDN.Glyph := ImgArrDnON;
    ButtonToRepeat := BVOLDN;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BVOLDNMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    if RTXState.Volume < 98 then BVOLDN.Glyph := ImgArrDnOFF;
    if RTXState.Volume >= 0 then BVOLUP.Glyph := ImgArrUpOFF;
    In_Command := FALSE;
end;


// Volume up
procedure TTRP.BVOLUPClick(Sender: TObject);

var s: string;

begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    if RTXState.Volume > 0 then begin
        dec(RTXState.Volume);
        s := IntToStr(RTXState.Volume);
        if length(s) < 2 then s := '0'+s;
        if not SendCommand(AF_GainSet, s+stCR) then
            Message(COMMANDFAILED)
        else
            Message('Volume attenuation: '+IntToStr(RTXState.Volume));
    end;
    UpdatePanel;
    In_Command := FALSE;
end;

procedure TTRP.BVOLUPMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) then exit;

    In_Command := TRUE;
    BVOLUP.Glyph := ImgArrUpON;
    ButtonToRepeat := BVOLUP;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BVOLUPMouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
    if RTXState.Volume > 1 then BVOLUP.Glyph := ImgArrUpOFF;
    if RTXState.Volume <= 99 then BVOLDN.Glyph := ImgArrDnOFF;
    In_Command := FALSE;
end;

//
// Buttons handling (block 2: Mode)
//

// USB
procedure TTRP.BUSBClick(Sender: TObject);
begin
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);
    case KeyboardState of
        NORMAL: begin
            if SendCommand(Mode_USB,'') then begin
                RTXState.Mode_RX := M_USB;
                RTXState.Mode_TX := M_USB;
                sMode_RX := '';
                sMode_TX := '';
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
            end else
        	    Message(COMMANDFAILED);
        end;
        SETRXF: begin
            if (RTXState.Mode_TX in [M_USB,M_LSB,M_AM,M_R3E]) then begin
                sMode_RX := Mode_USB;
                RTXState.Mode_RX := M_USB;
                KeyboardState := SETRXM;
                BENTERClick(Sender);
            end else Message(INVALIDSPLIT);
        end;
        SETTXF: begin
            if (RTXState.Mode_RX in [M_USB,M_LSB,M_AM]) then begin
                sMode_TX := Mode_USB;
                RTXState.Mode_TX := M_USB;
                KeyboardState := SETTXM;
                BENTERClick(Sender);
            end else Message(INVALIDSPLIT);
        end;
        SETRXTXF: begin
      	    Message(NOTALLOWED);
        end;
    end;
    In_Command := FALSE;
end;

// LSB
procedure TTRP.BLSBClick(Sender: TObject);
begin
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);
    case KeyboardState of
        NORMAL: begin
            if SendCommand(Mode_LSB,'') then begin
                RTXState.Mode_RX := M_LSB;
                RTXState.Mode_TX := M_LSB;
                sMode_RX := '';
                sMode_TX := '';
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
            end else
            	Message(COMMANDFAILED);
        end;
        SETRXF: begin
            if (RTXState.Mode_TX in [M_USB,M_LSB,M_AM,M_R3E]) then begin
                sMode_RX := Mode_LSB;
                RTXState.Mode_RX := M_LSB;
                KeyboardState := SETRXM;
                BENTERClick(Sender);
            end else Message(INVALIDSPLIT);
        end;
        SETTXF: begin
            if (RTXState.Mode_RX in [M_USB,M_LSB,M_AM]) then begin
                sMode_TX := Mode_LSB;
                RTXState.Mode_TX := M_LSB;
                KeyboardState := SETTXM;
                BENTERClick(Sender);
            end else Message(INVALIDSPLIT);
          end;
        SETRXTXF: begin
		    Message(NOTALLOWED);
        end;
        end;
    In_Command := FALSE;
end;

// AM
procedure TTRP.BAMClick(Sender: TObject);
begin
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);
        case KeyboardState of
            NORMAL: begin
                if SendCommand(Mode_AM,'') then begin
                    RTXState.Mode_RX := M_AM;
                    RTXState.Mode_TX := M_AM;
                    sMode_RX := '';
                    sMode_TX := '';
                    RTXState.Filter:=FILTER_DEFAULT;
                    RTXstate.AGC := AVC_FAST;
                    UpdatePanel;
                end else
            	    Message(COMMANDFAILED);
            end;
            SETRXF: begin
                if (RTXState.Mode_TX in [M_USB,M_LSB,M_AM,M_R3E]) then begin
                    sMode_RX := Mode_AM;
                    RTXState.Mode_RX := M_AM;
                    KeyboardState := SETRXM;
                    BENTERClick(Sender);
                end else Message(INVALIDSPLIT);
            end;
            SETTXF: begin
                if (RTXState.Mode_RX in [M_USB,M_LSB,M_AM]) then begin
                    sMode_TX := Mode_AM;
                    RTXState.Mode_TX := M_AM;
                    KeyboardState := SETTXM;
                    BENTERClick(Sender);
                end else Message(INVALIDSPLIT);
            end;
            SETRXTXF: begin
                Message(NOTALLOWED);
            end;
        end;
        In_Command := FALSE;
end;

// Jump to 500 kHz
procedure TTRP.B500Click(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);

    if SendCommand(F500k,'') then begin
        with RTXState do begin
            Freq_RX := 500000;
            Mode_RX := M_MCW;
            Mode_TX := M_MCW;
            sMode_RX := '';
            sMode_TX := '';
            Squelch_Enabled := FALSE;
            Speaker_Enabled := TRUE;
            RFAMP_Enabled := FALSE;
            RFATT_Enabled := FALSE;
            AGC := AVC_ON;
            Filter := FILTER_INTERMEDIATE;
        end;
        UpdatePanel;
        DispRXf;
    end else
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

// TELEX
procedure TTRP.BTELEXClick(Sender: TObject);
begin
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);
    case KeyboardState of
        NORMAL: begin
            if SendCommand(Mode_TELEX,'') then begin
                RTXState.Mode_RX := M_TLX;
                RTXState.Mode_TX := M_TLX;
                sMode_RX := '';
                sMode_TX := '';
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_FAST;
                UpdatePanel;
            end else
            	Message(COMMANDFAILED);
        end;
        SETRXF,SETTXF: Message(INVALIDSPLIT);
        SETRXTXF: begin
            Message(NOTALLOWED);
        end;
    end;
    In_Command := FALSE;
end;

// R3E
procedure TTRP.BR3EClick(Sender: TObject);
begin
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);
    case KeyboardState of
        NORMAL: begin
            if SendCommand(Mode_R3E,'') then begin
                RTXState.Mode_RX := M_R3E;
                RTXState.Mode_TX := M_R3E;
                sMode_RX := '';
                sMode_TX := '';
                RTXState.Filter:=FILTER_DEFAULT;
                RTXstate.AGC := AVC_SLOW;
                UpdatePanel;
            end else
            	Message(COMMANDFAILED);
        end;
        SETRXF: begin
            Message(INVALIDSPLIT);
        end;
        SETTXF: begin
            if (RTXState.Mode_RX in [M_USB,M_LSB,M_AM]) then begin
                sMode_TX := Mode_R3E;
                RTXState.Mode_TX := M_R3E;
                KeyboardState := SETTXM;
                BENTERClick(Sender);
            end else Message(INVALIDSPLIT);
        end;
        SETRXTXF: begin
            Message(NOTALLOWED);
        end;
    end;
    In_Command := FALSE;
end;

// Jump to 2182 kHz
procedure TTRP.B2182Click(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);

    if SendCommand(F2182k,'') then begin
        with RTXState do begin
            Freq_RX := 2182000;
            Freq_Tx := 2182000;
            // Mode_RX := M_AM;
            // Mode_TX := M_AM;
            Mode_RX := M_2182k;
            Mode_TX := M_2182k;
            sMode_RX := '';
            sMode_TX := '';
            TX_Enabled := TRUE;
            Squelch_Enabled := FALSE;
            Speaker_Enabled := TRUE;
            RFAMP_Enabled := FALSE;
            RFATT_Enabled := FALSE;
            AGC := AVC_ON;
            Filter := FILTER_DEFAULT;
            TX_Power := FULL_POWER;
        end;
        UpdatePanel;
        DispRXf;
        DispTXf;
    end else
        Message(COMMANDFAILED);
    In_Command := FALSE;
end;

// CW
procedure TTRP.BCWClick(Sender: TObject);
begin
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);
    case KeyboardState of
        NORMAL: begin
            if SendCommand(Mode_CW,'') then begin
                RTXState.Mode_RX := M_CW;
                RTXState.Mode_TX := M_CW;
                sMode_RX := '';
                sMode_TX := '';
                RTXState.Filter:=FILTER_INTERMEDIATE;
                RTXstate.AGC := AVC_FAST;
                BWIDE.Enabled := TRUE;
                BINTER.Enabled := TRUE;
                BNAR.Enabled := TRUE;
                BVNAR.Enabled := TRUE;
                SetActiveButtons;
                UpdatePanel;
            end else
            	Message(COMMANDFAILED);
        end;
        SETRXF,SETTXF: Message(INVALIDSPLIT);
    end;
    In_Command := FALSE;
end;

// MCW
procedure TTRP.BMCWClick(Sender: TObject);
begin
    In_Command := TRUE;
    if RTXState.PTT_State then Message(YOUAREINTX);
    case KeyboardState of
        NORMAL: begin
            if SendCommand(Mode_MCW,'') then begin
                RTXState.Mode_RX := M_MCW;
                RTXState.Mode_TX := M_MCW;
                sMode_RX := '';
                sMode_TX := '';
                RTXState.Filter:=FILTER_INTERMEDIATE;
                RTXstate.AGC := AVC_SLOW;
                SetActiveButtons;
                UpdatePanel;
            end else
            	Message(COMMANDFAILED);
        end;
        SETRXF,SETTXF: Message(INVALIDSPLIT);
    end;
    In_Command := FALSE;
end;

//
// Buttons handling (block 3: numeric keypad & frequency entry)
//

// RX
procedure TTRP.BRXClick(Sender: TObject);
begin
    case KeyboardState of
        NORMAL: begin
            KeyboardState := SETRXF;
            OldRXFreq := RXfreq.Caption;
            RXfreq.Caption := '_';
            RXFBuf := '';
            sMode_RX := '';
        end;
        SETTXF: begin
            KeyboardState := SETRXTXF;
            OldRXFreq := RXfreq.Caption;
            RXfreq.Caption := '_';
            RXFBuf := '';
            sMode_RX := '';
        end;
        SETRXTXF: begin
            RXfreq.Caption := '_';
            RXFBuf := '';
            TXfreq.Caption := '_';
            TXFBuf := '';
        end;
        SETTIME:begin
            OldTXFreq := TXfreq.Caption;
            TXfreq.Caption := '';
            TXFBuf := '';
            sMode_TX := '';
            KeyboardState := SETWAKEUP;
        end;
        SETRXF: begin
            RXfreq.Caption := '_';
            RXFBuf := '';
            sMode_RX := '';
        end;
        SETWAKEUP: begin
            TXfreq.Caption := '';
            TXFBuf := '';
            sMode_TX := '';
        end;
    end;
    SetActiveButtons;
end;

// Recall channel
procedure TTRP.BRCLClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) and (KeyboardState <> CHANNEL) then exit;

    OldRXFreq := RXFreq.Caption;
    if KeyboardState = NORMAL then OLDRTXState := RTXState;
    RXFreq.Caption := '';
    KeyboardState := RCLCH;
    Message(ENTERCHANNEL);
    SetActiveButtons;
end;

// TX
procedure TTRP.BTXClick(Sender: TObject);
begin
    if not RTXstate.TX_Enabled then exit;

    case KeyboardState of
        NORMAL: begin
            OldTXFreq := TXfreq.Caption;
            TXfreq.Caption := '_';
            TXFBuf := '';
            sMode_TX := '';
            KeyboardState := SETTXF;
        end;
        SETRXF: begin
            OldTXFreq := TXfreq.Caption;
            TXfreq.Caption := '_';
            TXFBuf := '';
            sMode_TX := '';
            KeyboardState := SETRXTXF;
        end;
        SETTXF: begin
            TXfreq.Caption := '_';
            TXFBuf := '';
            sMode_TX := '';
        end;
        SETRXTXF: begin
            RXfreq.Caption := '_';
            RXFBuf := '';
            TXfreq.Caption := '_';
            TXFBuf := '';
        end;
    end;
    SetActiveButtons;
end;

// 0
procedure TTRP.B0Click(Sender: TObject);
begin
    KeyboardHandler('0');
end;

// 1
procedure TTRP.B1Click(Sender: TObject);
begin
    KeyboardHandler('1');
end;

// 2
procedure TTRP.B2Click(Sender: TObject);
begin
    KeyboardHandler('2');
end;

// 3
procedure TTRP.B3Click(Sender: TObject);
begin
    KeyboardHandler('3');
end;

// 4
procedure TTRP.B4Click(Sender: TObject);
begin
    KeyboardHandler('4');
end;

// 5
procedure TTRP.B5Click(Sender: TObject);
begin
    KeyboardHandler('5');
end;

// 6
procedure TTRP.B6Click(Sender: TObject);
begin
    KeyboardHandler('6');
end;

// 7
procedure TTRP.B7Click(Sender: TObject);
begin
    KeyboardHandler('7');
end;

// 8
procedure TTRP.B8Click(Sender: TObject);
begin
    KeyboardHandler('8');
end;

// 9
procedure TTRP.B9Click(Sender: TObject);
begin
    KeyboardHandler('9');
end;

// BENTER
procedure TTRP.BENTERClick(Sender: TObject);

var f: longint;
    sf,cmd,regname: string;
    chn,hhmm,regval,len,i: integer;

begin
    case KeyboardState of
    SETRXF: begin
        sf := RXFreq.Caption;
        if sf = '_' then sf := OldRXFreq;
        f := trunc(StrToFloat(AdjustDecimalSeparator(sf)) * 1000);
        if (f >= MINRXF) and (f < MAXRXF) then begin
            RTXstate.Freq_rx := f;
			if not SetRXFreq then Message(COMMANDFAILED);
        end else Message(RXCANTTUNE);
        RXFBuf := '';
        DIspRXf;
    end;
    SETRXM: begin
        if not SetRXMode then Message(COMMANDFAILED);
        DispRXf;
    end;
    SETTXF: begin
        sf := TXFReq.Caption;
        if sf = '_' then sf := OldTXFreq;
        f := trunc(StrToFloat(AdjustDecimalSeparator(sf)) * 1000);
        if (f >= MINTXF) and (f <= MAXTXF) then begin
            RTXState.Freq_tx := f;
            if not SetTXFreq then Message(COMMANDFAILED);
        end else Message(TXCANTTUNE);
        TXFBuf := '';
        DispTXf;
    end;
    SETTXM: begin
        if not SetTXMode then Message(COMMANDFAILED);
        DispTXf;
    end;
    SETRXTXF: begin
        sf := RXFreq.Caption;
        if sf = '_' then sf := OldRXFreq;
        f := trunc(StrToFloat(AdjustDecimalSeparator(sf)) * 1000);
        if (f >= MINRXF) and (f <= MAXRXF) then begin
            if (f >= MINTXF) and (f <= MAXTXF) then begin
                RTXState.Freq_RX := f;
                RTXState.Freq_TX := f;
                if not SetRXTXFreq then Message(COMMANDFAILED);
            end else Message(TXCANTTUNE);
        end else Message(RXCANTTUNE);
        KeyboardState := NORMAL;
        TXFBuf := '';
        DispRXf;
        DispTXf;
    end;
    STOCH: begin
        if RXFreq.Caption <> '' then begin
            chn := StrToInt(RXFREQ.Caption);
            if not SendCommand(Store, RXFREQ.Caption+stCR) then
            Message(COMMANDFAILED);
        end;
       	RXFBuf := '';
        DispRXf;
    end;
    RCLCH: begin
        sf := RXFreq.Caption;
        if sf <> '' then begin
            chn := StrToInt(RXFREQ.Caption);
            if SendCommand(Recall, sf+stCR) then begin
                RTXState.Freq_RX := -chn;
                RTXState.Freq_TX := -chn;
                SetAllLEDsOff;
                KeyboardState := CHANNEL;
                Message(CHANNELMODE);
            end else
                Message(COMMANDFAILED);
		    RXFBuf := '';
        end;
        DispRXf;
        DispTXf;
    end;
    SETTIME: begin
        if TXFBuf <> '' then begin
            if length(TXFBuf) = 4 then begin
	            hhmm := StrToInt(TXFBuf);
        	    if (hhmm div 100 < 24) and (hhmm mod 100 < 60) then begin
                    if not SendCommand(Set_Time, TXFBuf+stCR) then
                        Message(COMMANDFAILED);
	            end;
            end else Message(INVALIDTIME);
        end;
        TXFBuf := '';
        DispTXf;
        if not RTXState.TX_Enabled then Clock.Enabled := TRUE;
    end;
    SETBFO: begin
        if length(RXfBuf) = 2 then
            RXFBuf := RXFBuf[1]+'0'+RXFBuf[2];
        if length(RXFBuf) = 3 then begin
            if not SendCommand(Set_BFO, RXFbuf+stCR) then
                Message(COMMANDFAILED)
            else
                RTXState.BFO_freq := 100*StrToInt(RXFBuf);
        end;
        DispRXF;
        BMINUS.Visible := FALSE;
        BENTER.Width := 124;
    end;
    SETWAKEUP: begin
        if TXFBuf <> '' then begin
            if length(TXFBuf) = 4 then begin
                if not SendCommand(Set_Time+RX_Cmd, TXFreq.Caption) then
                    Message(CommandFailed);
                DispTXf;
            end else Message(INVALIDTIME);
        end;
    end;
    SETOR,SETPR,SETGR: begin
        if RXFBuf <> '' then begin
            len := length(RXFBuf);
            regval := 0;
            for i := len downto 1 do
                if RXFBuf[i] = '1' then regval := regval + (1 shl (len - i));
                case KeyboardState of
                    SETOR: begin
                        cmd := Set_Option_Reg;
                        regname := 'Option';
                    end;
                    SETPR: begin
                        cmd := Set_Preset_Reg;
                        regname := 'Preset';
                    end;
                    SETGR: begin
                        cmd := Set_Guard_Reg;
                        regname:= 'Guard';
                    end;
                end;
                if not Sendcommand(cmd,IntToStr(regval)+stCR) then
                    Message(COMMANDFAILED)
                else
                    Message(regname+' register set to '+IntToStr(regval));
            end;
            DispRXf;
            KeyboardState := NORMAL;
        end;
        SELFTSTM,SELFTSTFMM1: begin
            if SendCommand(stCR,'') then
                AbortTest := TRUE
            else
                Message(COMMANDFAILED);
        end;
        SELFTSTFMA: begin
            KeyboardState := SELFTSTFMA1;
            SetActiveButtons;
            if SendCommand(Exec_AST_Num, RXFBuf+stCR) then begin
                if GetAutoSelfTestResponse then BONOFFClick(Sender);
            end else Message(INVALIDTESTNUM);
            DispRXf;
            KeyboardState := NORMAL;
        end;

        SELFTSTFMM: begin
            if SendCommand(Exec_MST_Num, RXFBuf+stCR) then begin
                KeyBoardState := SELFTSTFMM1;
                SetActiveButtons;
                if GetManSelfTestResponse then
                    BONOFFClick(self)
                else begin
                    Message(COMMANDFAILED);
                    DispRXf;
                    KeyboardState := NORMAL;
                end;
            end;
        end;
        FILLSCNBUF: begin
            if (RXFreq.Caption = '_') and (m = 1) then begin
                if not SendCommand(Fill_Scan_Buf, '') then
                    Message(COMMANDFAILED);
                for i := 1 to n-1 do begin
                    RXFBuf := ScanBuf[i,1];
                    while length(RXFbuf) < 6 do RXFBuf := '0'+RXFBuf;
                    TXFBuf := ScanBuf[i,2];
                    while length(TXFbuf) < 6 do TXFBuf := '0'+TXFBuf;
                    if not SendCommand(RX_Prefix+RXFBuf,TX_Prefix+TXFBuf) then
                        Message(COMMANDFAILED);
                end;
                if not SendCommand(stCR,'') then
                    Message(COMMANDFAILED);
                DispRXf;
                DispTXf;
            end else begin
                if m = 1 then begin
                    ScanBuf[n,m] := RXFBuf;
                    m := 2;
                    TXFBuf := '';
                    TXFreq.Caption := '_';
                    exit;
                end else begin
                    ScanBuf[n,m] := TXFBuf;
                    TXFReq.Caption := '';
                    RXFBuf := '';
                    TXFBuf := '';
                    RXFreq.Caption := '_';
                    m := 1;
                    n := n + 1;
                    exit;
                end;
            end;
        end;
        SCANCH: begin
            if not SendCommand(stCR, '') then begin
   		        Message(COMMANDFAILED);
            end else begin
                RXFreq.Caption := 'STOPPED';
                TXFReq.Caption := 'STOPPED';
                RTXState.Scan := FALSE;
            end;
        end;
        NORMAL: begin
            if not SendCommand(stCR, '') then begin
		        Message(COMMANDFAILED);
            end;
        end;
    end;
    if not (KeyboardState in [CHANNEL,SCANTUBUF,SCANCH]) then
        KeyboardState := NORMAL;
    UpdatePanel;
end;

//
// Buttons handling (block 4: TUNE & power level)
//

// TUNE
procedure TTRP.BTUNEClick(Sender: TObject);
var s: string;
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;
    Enable_Status := FALSE;
    if SendCommand(TX_TUNE,'') then begin
        s := GetReply(1,TUNETIMEOUT);
        if s = '>' then begin
            Message('Tuning completed');
        end else
            Message(COMMANDFAILED);
    end;
    UpdatePanel;
    Enable_Status := TRUE;
end;

// Low power
procedure TTRP.BLOWClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if SendCommand(TX_LowPwr, '') then begin
        RTXState.TX_power := LOW_POWER;
        UpdatePanel;
    end else
        Message(COMMANDFAILED);
end;

// Medium power
procedure TTRP.BMEDClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if SendCommand(TX_MediumPwr,'') then begin
        RTXState.TX_power := MEDIUM_POWER;
        UpdatePanel;
    end else
        Message(COMMANDFAILED);
end;

// Full power
procedure TTRP.BFULLClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if SendCommand(TX_HighPwr,'') then begin
        RTXState.TX_power := FULL_POWER;
        UpdatePanel;
    end else
        Message(COMMANDFAILED);
end;

//
// Buttons handling (block 5 row 1: misc functions 2)
//

// Store channel
procedure TTRP.BSTOClick(Sender: TObject);
begin
    case KeyboardState of
        NORMAL: begin
            RXFreq.Caption := '';
            RXFBuf := '';
            KeyboardState := STOCH;
            Message(ENTERCHANNEL);
        end;
        STOCH: RXFreq.Caption := '';
    end;
    SetActiveButtons;
end;

// Scan
procedure TTRP.BSCANClick(Sender: TObject);
begin
    Message('Scan syntax not implemented');
    // exit;
    Message('Press ENTER to stop');

    if not (KeyboardState in [NORMAL,SCANCH]) then exit;

    if not SendCommand(Scan+Scan,'') then
        Message(COMMANDFAILED)
    else begin
        KeyBoardState := SCANCH;
        OldRXFreq := RXFreq.Caption;
        RXFreq.Caption := 'SCAN';
        TXFreq.Caption := 'SCAN';
        RTXState.Scan := TRUE;
        DisableAllButtons;
        SetActiveButtons;
        UpdatePanel;
    end;
end;

// Set clock
procedure TTRP.BSETTClick(Sender: TObject);

var t: TDateTime;

begin
    case KeyboardState of
        NORMAL: begin
            Clock.Enabled := FALSE;
            KeyboardState := SETTIME;
            TxFreq.Caption := '_';
            TXFBuf := '';
            Message(ENTERTIME)
        end;
        SETTIME: begin
            TxFreq.Caption := '';
            if MUSEUTC.Checked then
                t := LocalTimeToUniversal(now)
            else
                t := now;
            TXFBuf := FormatDateTime('hhnn', t);
            TXFreq.Caption := TXFBuf;
        end;
        SETWAKEUP: begin
            TxFreq.Caption := '';
            TXFBuf := '';
        end;
    end;
    SetActiveButtons;
end;

// "+-" key (shown only when setting BFO)
procedure TTRP.BMINUSClick(Sender: TObject);
begin
    if KeyboardState = SETBFO then begin
        if length(RXFBuf) = 1 then begin
            if RXfBuf = '-' then RXFBuf := '+' else RXFBuf := '-';
        end;
        if length(RXfBuf) = 0 then RXFBuf := '-';
        RXFreq.Caption := RXFBuf;
     end;
end;

// Duplex
procedure TTRP.BDUPClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if SendCommand(Duplex, '') then begin
        RTXState.Duplex := not RTXState.Duplex;
        UpdatePanel;
        // we must do something?
    end else
        Message(COMMANDFAILED);
end;

//
// Buttons handling (block 5 row 2: Dimmer)
//

// Dimmer down
procedure TTRP.BDIMDNClick(Sender: TObject);
begin
    case KeyboardState of
        NORMAL: begin
            if RTXState.Dimmer_Level > 0 then begin
            Dec(RTXState.Dimmer_Level);
            if SendCommand(Dimmer_Set,IntToStr(RTXState.Dimmer_Level) + stCR) then
                Message('Dimmer level = '+IntToStr(RTXState.Dimmer_Level))
            else
                Message(COMMANDFAILED)
            end;
        end;
     	SELFTSTM,SELFTSTFMM1: begin
            if SendCommand(Dimmer_Dn,'') then
                NextTest := TRUE
            else
           		Message(COMMANDFAILED);
        end;
    end;
end;

// Setup Dimmer Down autorepeat
procedure TTRP.BDIMDNMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    ButtonToRepeat := BDIMDN;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BDIMDNMouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
end;

// Dimmer up
procedure TTRP.BDIMUPClick(Sender: TObject);
begin
    case KeyboardState of
        NORMAL: begin
            if RTXState.Dimmer_Level < 5 then begin
                Inc(RTXState.Dimmer_Level);
            	if SendCommand(Dimmer_Set,IntToStr(RTXState.Dimmer_Level) + stCR) then
               	    Message('Dimmer level = '+IntToStr(RTXState.Dimmer_Level))
            	else
               	    Message(COMMANDFAILED)
            end;
        end;
     	SELFTSTM,SELFTSTFMM1: begin
            if SendCommand(Dimmer_Up,'') then
                NextTest := TRUE
            else
           		Message(COMMANDFAILED);
        end;
    end;
end;

// Setup Dimmer Up autorepeat
procedure TTRP.BDIMUPMouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    ButtonToRepeat := BDIMUP;
    RPT.Interval := 300;
    enough := FALSE;
    RPT.Enabled := TRUE;
end;

procedure TTRP.BDIMUPMouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    enough := TRUE;
    RPT.Enabled := FALSE;
    ButtonToRepeat := nil;
end;

//
// Buttons handling (block 5 row 3: TX & power on/off )
//

// TX enabled/disabled
procedure TTRP.BTXONOFFClick(Sender: TObject);
begin
    if RTXState.PTT_State or (KeyboardState <> NORMAL) then exit;

    RTXState.TX_Enabled := not RTXState.TX_Enabled;
    if RTXState.TX_Enabled then begin
        if not SendCommand(TX_On,'') then
            Message(COMMANDFAILED);
        SetTXfreq;
        DispTXF;
    end else begin
        if not SendCommand(TX_Off,'') then Message(COMMANDFAILED);
    end;
    UpdatePanel;
end;

// Power on/off (NB: Starts & exits program, does not switch on&off radio!)
procedure TTRP.BONOFFClick(Sender: TObject);

begin
    if SerPort > 0 then begin
        BONOFF.Caption := 'SUPPLY ON';
        Enable_Status := FALSE;
        if MStatus.Checked then begin
            TSTatus.Enabled := FALSE;
            Enable_Status := FALSE;
        end;
        CloseRemote;
        SerFlush(SerPort);
        SerClose(SerPort);
        SerPort := 0;
        SaveConfig;
        SaveLastState;
        sMode_RX := '';
        RXFreq.Caption := '';
        TXFreq.Caption := '';
        sMode_TX := '';
        SM.Enabled := FALSE;
        TSTATUS.Enabled := FALSE;
        SMETER.Position := 0;
        DisableAllControls;
        KeyboardState := POWEROFF;
    end else begin
        MSG.Lines.Clear;
        BONOFF.Caption := 'SUPPLY OFF';
        In_Command := FALSE;
        In_Wheel := FALSE;
        Enough := TRUE;
        ReadConfig;
		SerPort := SerOpen(SerPortName);
            if SerPort > 0 then begin
                if M300B.Checked then begin
                SerSetParams(SerPort,300,7,OddParity,1,[]);
            end;
            if M2400B.Checked then begin
                SerSetParams(SerPort,2400,7,OddParity,1,[]);
            end;
     		SerSetDTR(SerPort,True);
     		SerSetRTS(SerPort,True);

            if OpenRemote then begin
                KeyboardState := NORMAL;
                EnableAllControls;
                LoadLastState;
                RestoreState;
                if RTXState.Volume < 99 then
                    BVOLDN.Glyph := ImgArrDnOFF
                else
                    BVOLDN.Glyph := ImgArrDnON;
                if RTXState.Volume > 0 then
                    BVOLUP.Glyph := ImgArrUpOFF
                else
                    BVOLUP.Glyph := ImgArrUpON;
                ReducedPower := FALSE;
                HighSWR := FALSE;
                UpdatePanel;
            end else begin
                SerFlush(SerPort);
                SerClose(SerPort);
                SerPort := 0;
                if Application.MessageBox(
                    'Failed to initialize communications.'
                    +LineEnding
                    +'Retry?',
                    'Error',
                    MB_ICONERROR+MB_YESNO) = ID_NO then begin
                    CloseProgram;
                end else begin
                    BONOFFClick(Sender);
                end;
            end;
	    end else begin
            ShowMessage('Can''t open serial port '+SerPortName);
        end
    end;
end;

//
// Extra program functions (not present in CU8000)
//

// Alternative tuning step selection way (click on indicators)

// 1 kHz step
procedure TTRP.STEP1KMouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if Button = mbLeft then begin
  	    if SendCommand(TuneStep1k, '') then begin
  		    RTXState.Freq_step := 1000;
  		    UpdatePanel;
        	DispRXf;
  	    end else
  		    Message(COMMANDFAILED);
    end;
end;

// 100 Hz step
procedure TTRP.STEP100HMouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if Button = mbLeft then begin
  	    if SendCommand(TuneStep100, '') then begin
		    RTXState.Freq_step := 100;
  		    UpdatePanel;
        	DispRXf;
  	    end else
  		    Message(COMMANDFAILED);
    end;
end;

// 10 Hz step
procedure TTRP.STEP10HMouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if Button = mbLeft then begin
  	    if SendCommand(TuneStep10, '') then begin
            RTXState.Freq_step := 10;
        	UpdatePanel;
        	DispRXf;
    end else
  	    Message(COMMANDFAILED);
    end;
end;

// Alternative frequency setting way: left/right click on the frequency figures
// Clicking on the decimal point rewrites displayed frequency
procedure TTRP.RXfreqMouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);

var step: integer;

begin
    if (KeyboardState <> NORMAL) or In_RXFreqMouseUp then exit;

    In_RXFreqMouseUp := TRUE;
    TXFreqModified := FALSE;
    case X of
        0..31:    step := 10000000;
        32..63:   step := 1000000;
        64..95:   step := 100000;
        96..127:  step := 10000;
        128..159: step := 1000;
        160..191: step := 0; 		// click on decimal point
        192..223: step := 100;
        otherwise begin
            In_RXFreqMouseUp := FALSE;
            exit;
        end;
    end;
    if Button = mbLeft then begin
        if RTXState.Freq_rx - step >= MINRXF then
	    RTXState.Freq_rx := RTXState.Freq_rx-step;
    end;
    if Button = mbRight then begin
        if RTXState.Freq_rx + step <= MAXRXF then
		RTXState.Freq_rx := RTXState.Freq_rx+step;
	end;
    if not SetRXFreq then Message(COMMANDFAILED);
    DispRXf;

    if RTXState.TX_Enabled and MIMMU.checked then begin
        RTXState.Freq_tx := 100*((RTXState.Freq_rx+50) div 100);
        if not SetTXFreq then Message(COMMANDFAILED);
        DispTXf;
    end;
    In_RXFreqMouseUp := FALSE;
    UpdateFTXTimeout := time+TXUPTIMEOUT;
end;

// Same for TX
procedure TTRP.TXfreqMouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);

var step: integer;

begin
    if (KeyboardState <> NORMAL) or In_TXFreqMouseUp then exit;

    In_TXFreqMouseUp := TRUE;
    TXFreqModified := TRUE;
    if RTXState.TX_Enabled then begin
	    case X of
	        0..31:    step := 10000000;
        	32..63:   step := 1000000;
            64..95:   step := 100000;
	        96..127:  step := 10000;
        	128..159: step := 1000;
            160..191: step := 0;	// click on decimal point
	        192..223: step := 100;
            otherwise begin
                In_TXFreqMouseUp := FALSE;
                exit;
            end;
        end;
        if Button = mbLeft then begin
		    if RTXState.Freq_tx - step >= MINTXF then
        	    RTXState.Freq_tx := RTXState.Freq_tx-step;
	    end;
        if Button = mbRight then begin
	        if RTXState.Freq_tx + step <= MAXTXF then
        	    RTXState.Freq_tx := RTXState.Freq_tx+step;
	    end;
        if not SetTXFreq then Message(COMMANDFAILED);
	    DispTXf;

        if MIMMU.Checked then begin
            RTXState.Freq_rx := RTXState.Freq_tx;
        	if not SetRXFreq then Message(COMMANDFAILED);
	        DispRXf;
        end;
    end;
    In_TXFreqMouseUp := FALSE;
    UpdateFTXTimeout := time+TXUPTIMEOUT;
end;

// Switch receive/transmit. In transmit sends " command every 2s
// (" has 3s internal timeout)
// This command works in all modes except CW and MCW, but TX audio
// comes always from REMOTE inputs (TELEX and/or AUX?) and CU
// microphone input (LOCAL) is ignored since priority is never released.
procedure TTRP.BTRANSClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) and (KeyboardState <> CHANNEL) then exit;

    RTXState.PTT_state := not RTXState.PTT_State;

    if RTXState.PTT_State then begin
	    if not SendCommand(TX_Cmd,'') then begin
            Message(COMMANDFAILED);
            RTXState.PTT_state := not RTXState.PTT_State;
        end;
        TX.Enabled := TRUE;
    end else begin
        if not SendCommand(RX_Cmd,'') then begin
            Message(COMMANDFAILED);
            RTXState.PTT_state := not RTXState.PTT_State;
        end;
        TX.Enabled := FALSE;
    end;
    UpdatePanel;
end;

// Copy RX frequency to TX frequency
procedure TTRP.BTXEQRXClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if (RTXState.Freq_RX >= MINTXF) and (RTXState.Freq_RX <= MAXTXF) then begin
        RTXState.Freq_tx := 100*((RTXState.Freq_rx + 50) div 100);
        SetTXFreq;
        DispTXf;
    end else Message(TXCANTTUNE);
end;

// Copy TX frequency to RX frequency
procedure TTRP.BRXEQTXClick(Sender: TObject);
begin
    if (KeyboardState <> NORMAL) or In_Command then exit;

    if (RTXState.Freq_TX >= MINRXF) and (RTXState.Freq_TX <= MAXRXF) then begin
        RTXState.Freq_rx := RTXState.Freq_tx;
        SetRXTXFreq;
        DispRXf;
        DispTXf;
    end;
end;

// Allows to use mouse wheel for tuning
procedure TTRP.FormMouseWheel(Sender: TObject; Shift: TShiftState;
          WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);

const FYRange=[12..50];

var step: integer = -1;

begin

    if In_Wheel or (KeyboardState <> NORMAL) then exit;
    In_Wheel := TRUE;
{$IFDEF Test}
    Message('X='+IntToStr(Mousepos.X)+' y='+IntToStr(MousePos.Y));
{$ENDIF}
    // Set step size if cursor over RX or TX frequency display
    if MousePos.Y in FYRange then begin
        case MousePos.X of
	        0..31, 520..551: step := 10000000;
            32..63, 552..583: step := 1000000;
            64..95, 584..615: step := 100000;
	        96..127, 616..647: step := 10000;
            128..159, 648..679: step := 1000;
            160..191, 680..711: step := 0;	// wheel on decimal point
	        192..223, 712..743: step := 100;
            224..255: begin
                // wheel on 10 Hz figure, can't set frequency in 10 Hz steps
                Handled := TRUE;
                In_Wheel := FALSE;
                exit;
            end;
            otherwise step := -1;
        end;
    end;

    if (MousePos.Y in FYRange) and (MousePos.X in [0..223]) then begin
        // Mouse wheel over RX frequency display
        TXFreqModified := FALSE;
        if WheelDelta > 0 then begin
            if step >= 0 then begin
	            if RTXState.Freq_rx + step <= MAXRXF then begin
                    RTXState.Freq_rx := RTXState.Freq_rx + step;
                    if not SetRXFreq then Message(COMMANDFAILED);
	                DispRXf;
                end else Message(RXCANTTUNE);
            end;
        end;
        if WheelDelta < 0 then begin
            if step >= 0 then begin
	            if RTXState.Freq_rx - step >= MINRXF then begin
                    RTXState.Freq_rx := RTXState.Freq_rx-step;
                    if not SetRXFreq then Message(COMMANDFAILED);
	                DispRXf;
                end else Message(RXCANTTUNE);
            end;
        end;
        if MIMMU.Checked then begin
            if RTXState.freq_rx >= MINTXF then begin
                RTXState.Freq_tx := 100*((RTXState.Freq_rx+50) div 100);
                if not SetTXFreq then Message(COMMANDFAILED);
                DispTXf;
            end else Message(TXCANTTUNE);
        end;
     end;

     if (MousePos.Y in FYRange) and ((MousePos.X > 520)
         and (MousePOs.X < 744)) then begin
         // Mouse wheel over TX frequency display
         TXFreqModified := TRUE;
         if WheelDelta > 0 then begin
            if step >= 0 then begin
       	        if RTXState.Freq_tx + step <= MAXTXF then begin
                    RTXState.Freq_tx := RTXState.Freq_tx + step;
                    if not SetTXFreq then Message(COMMANDFAILED);
       	            DispTXf;
                end else Message(RXCANTTUNE);
            end;
         end;
         if WheelDelta < 0 then begin
            if step >= 0 then begin
       	        if RTXState.Freq_tx - step >= MINTXF then begin
                    RTXState.Freq_tx := RTXState.Freq_tx - step;
                    if not SetTXFreq then Message(COMMANDFAILED);
       	            DispTXf;
                end else Message(TXCANTTUNE);
            end;
         end;
         if MIMMU.Checked then begin
            RTXState.Freq_rx := RTXState.Freq_tx;
            if not SetRXFreq then Message(COMMANDFAILED);
            DispRXf;
         end;
     end;

     if not (((MousePos.Y in FYRange) and (MousePos.X in [0..255])) or
        ((MousePos.Y in FYRange) and
        ((MousePos.X > 520) and (MousePos.Y < 744)))) then begin
        TXFreqModified := FALSE;
        if WheelDelta > 0 then begin
            if SendCommand(Tune_Up, '') then begin
                if RTXState.Freq_rx+RTXState.Freq_step <= MAXRXF then begin
                    RTXState.Freq_rx := RTXState.Freq_rx + RTXState.Freq_step;
                    DispRXf;
                end else Message(RXCANTTUNE);
            end else Message(COMMANDFAILED);
        end;
        if WheelDelta < 0 then begin
            if SendCommand(Tune_Dn, '') then begin
                if RTXState.Freq_rx-RTXState.Freq_step >= MINRXF then begin
                    RTXState.Freq_rx := RTXState.Freq_rx - RTXState.Freq_step;
                    DispRXf;
                end else Message(RXCANTTUNE);
            end else Message(COMMANDFAILED);
        end;
        if MIMMU.Checked then begin
            if RTXState.freq_rx >= MINTXF then begin
                RTXState.Freq_tx := 100*((RTXState.Freq_rx+50) div 100);
                if not SetTXFreq then Message(COMMANDFAILED);
                DispTXf;
            end else Message(TXCANTTUNE);
        end;
     end;

     Handled := TRUE;
     In_Wheel := FALSE;
     UpdateFTXTimeout := time+TXUPTIMEOUT;
end;

//
// Timers
//

// Flash annunciator if split mode
procedure TTRP.FLASHTimer(Sender: TObject);

begin
    if RTXState.Mode_RX = RTXState.Mode_TX then exit;

    Mode_Flash := not Mode_Flash;
    if RTXState.PTT_State then begin
        if Mode_Flash then
       	    ButtonToFlashTX.Glyph := ImgON
        else
           	ButtonToFlashTX.Glyph := ImgOFF;
    end else begin
        if Mode_Flash then
            ButtonToFlashRX.Glyph := ImgON
        else
            ButtonToFlashRX.Glyph := ImgOFF;
    end;
    Application.ProcessMessages;
end;

// Timer to update S-meter, status LEDS and TX frequency every 250 ms
// Must be less than Status timer to be sure to display all measures.
procedure TTRP.SMTimer(Sender: TObject);

var i: integer;

begin
    SMETER.Position := s;
    WMETER.Position := t;

    if length(status)>0 then begin
        {$IFDEF TEST}
        Message('Status='+Status);
        {$ENDIF}
        for i := 1 to length(status) do begin
            case Status[i] of
	            'u': begin
                    Message('ATU8000 tuning successful');
        	    end;
	            'v': begin
	                Message('ATU8000 tuning erroneous');
                end;
                'w': begin
                    Message('SWR < 4');
                    HighSWR := FALSE;
                    ReducedPower := FALSE;
                end;
                'x': begin
               	    Message('SWR > 4');
                    HighSWR := TRUE;
       	        end;
		        'y': begin
      			    ReducedPower := FALSE;
                    Message('Power normal');
      			end;
        	    'z': begin
                    ReducedPower := TRUE;
                    Message('Power reduced');
                end;
                '>': begin
		            Message('Status: got >');
        		end;
            end;
        end;
        status := '';
        UpdatePanel;
    end;
end;

// Timer to update TX frequency in transceiver mode
procedure TTRP.TXFUpTimerTimer(Sender: TObject);
begin
    // if in deferred transceiver mode, update TX frequency if timeout expired
    if MDEFU.Checked and (time > UpdateFTXTimeout) and
        not (In_Wheel or In_TXFreqMouseUp or In_RXFreqMouseUp or In_Command) and
        (((RTXState.Freq_rx + 50) div 100) <> (RTXState.Freq_tx div 100)) then begin
        In_Command := TRUE;
        if TXFreqModified then begin
            RTXState.Freq_rx := RTXState.Freq_tx;
            if not SetRXFreq then Message(COMMANDFAILED);
            DispRXf;
        end else begin
            if RTXState.freq_rx >= MINTXF then begin
                RTXState.Freq_tx := 100*((RTXState.Freq_rx+50) div 100);
                if not SetTXFreq then Message(COMMANDFAILED);
                DispTXf;
            end else Message(TXCANTTUNE);
        end;
        In_Command := FALSE;
    end;
end;

// TX timer. If PTT active sends " command every 2s
procedure TTRP.TXTimer(Sender: TObject);
begin
    if RTXState.PTT_State then
        if not SendCommand(TX_cmd,'') then Message(COMMANDFAILED);
end;

// Clock timer. If TX off, shows time in the TX frequency display
procedure TTRP.ClockTimer(Sender: TObject);

var t: TDateTime;

begin
    if (not RTXState.TX_Enabled) AND (KeyboardState <> POWEROFF) then begin
        if MUSEUTC.Checked then
            t := LocalTimeToUniversal(now)
        else
            t := now;
        if Time_Flash then
            TXfreq.Caption := FormatDateTime('hh:nn', t)
		else
            TXfreq.Caption := FormatDateTime('hh nn', t);
            Time_Flash := not Time_Flash;
	end;
end;

// Repeat timer: repeat button in ButtonToRepeat
procedure TTRP.RPTTimer(Sender: TObject);
begin
    if In_repeat then exit;
    In_Repeat := TRUE;
    if not enough and (ButtonToRepeat <> nil) then
        ButtonToRepeat.OnClick(Sender);
     In_Repeat := FALSE;
end;


// Status timer. Get status (S & RF meters, etc.) every 500 ms.
procedure TTRP.TStatusTimer(Sender: TObject);

VAR buf: char = chr(0);
    sc, tc: char;
    nc: integer;

begin
    {$IFDEF TEST_USER_INTERFACE}
    s := 10;
    t := 5;
    status := 'uvwxyz';
    exit;
    {$ENDIF}
    if In_Command then exit;
    if Enable_Status then begin
        status := '';
	    SerWrite(SerPort, Get_Status[1], 1);

        timeout := time + CMDTIMEOUT;
        repeat
	        nc := SerRead(SerPort, buf, 1);
            {$IFDEF LINUX}
                sleep(1);
            {$ENDIF}
            {$IFDEF WINDOWS}
                sleep(0);
            {$ENDIF}
	    until (nc > 0) or (time > timeout);

        if time > timeout then begin
            Enable_Status := FALSE;
            MStatus.Checked := FALSE;
            Message(NOREPLY);
            exit;
        end;

        repeat
            timeout := time + CMDTIMEOUT;
            repeat
                nc := SerRead(SerPort, buf, 1);
                {$IFDEF LINUX}
                    sleep(1);
                {$ENDIF}
                {$IFDEF WINDOWS}
                    sleep(0);
                {$ENDIF}
            until (nc > 0) or (time > timeout);

            SerWrite(SerPort, stACK[1], 1);

            if (buf in StatusRange) then status := status+buf;
        until (buf in MetersRange) or (time > timeout);

        if time > timeout then begin
            Enable_Status := FALSE;
            MStatus.Checked := FALSE;
            Message(NOREPLY);
            exit;
        end;

        sc := buf;
        {$IFDEF TEST}
		Message('Got S='+sc);
        {$ENDIF}

        timeout := time + CMDTIMEOUT;
        repeat
            nc := SerRead(SerPort, buf, 1);
            {$IFDEF LINUX}
            sleep(1);
            {$ENDIF}
            {$IFDEF WINDOWS}
            sleep(0);
            {$ENDIF}
        until (nc > 0) or (time > timeout);

        if time > timeout then begin
            Enable_Status := FALSE;
            MStatus.Checked := FALSE;
            Message(NOREPLY);
            exit;
        end;

        tc := buf;

        // Disable status reading
        SerWrite(SerPort, stCAN[1], 1);

        timeout := time + CMDTIMEOUT;
		repeat
		    nc := SerRead(SerPort, buf, 1);
            {$IFDEF LINUX}
            sleep(1);
            {$ENDIF}
            {$IFDEF WINDOWS}
            sleep(0);
            {$ENDIF}
		until (nc > 0) or (time > timeout);

        if time > timeout then begin
            Enable_Status := FALSE;
            MStatus.Checked := FALSE;
            Message(NOREPLY);
            exit;
        end;

        {$IFDEF TEST}
        Message('status: '+status+' S:'+sc+' T:'+tc);
        {$ENDIF}

	    s := ord(sc) - ord('`');
	    t := ord(tc) - ord('`');

        {$IFDEF TEST}
        if (s<5) then
            Status := 'uwz'
        else
            if (s<10) then Status := 'vxy' else Status:='';
        {$ENDIF}
    end;
end;

// Things to do at startup
initialization

begin
    {$IFDEF LINUX}
    HomeDir := GetUserDir+'.SkantiControl/';
   	StateDir := HomeDir+'States/';
    ChannelsDir := HomeDir+'Channels/';
    ImgDir := '/usr/share/SkantiControl/Img/';
    {$ENDIF}
    {$IFDEF WINDOWS}
    HomeDir := GetUserDir+'SkantiControl\';
    StateDir := HomeDir+'States\';
    ChannelsDir := HomeDir+'Channels\';
    ImgDir := HomeDir+'Img\';
    {$ENDIF}
    pTmp := strAlloc(255);
   	if not DirectoryExists(HomeDir) then CreateDir(HomeDir);
   	if not DirectoryExists(StateDir) then CreateDir(StateDir);
    if not DirectoryExists(ChannelsDir) then CreateDir(ChannelsDir);
    if not DirectoryExists(ImgDir) then begin
        StrPCopy(pTmp,'Directory '+ImgDir+' not found.'+LineEnding+'Check your installation.');
        {$IFDEF WINDOWS}
        Application.Initialize;
        {$ENDIF}
        Application.MessageBox(pTmp, 'Installation error', MB_OK);
        halt;
    end;
    if not (FileExists(ImgDir+'off-red.bmp') and FileExists(ImgDir+'on-red.bmp') and
        FileExists(ImgDir+'off-green.bmp') and FileExists(ImgDir+'on-green.bmp') and
        FileExists(ImgDir+'off-yellow.bmp') and FileExists(ImgDir+'on-yellow.bmp')) then begin
        StrPCopy(pTmp,'Files ''off-<color>.bmp'' and/or ''on-<color>.bmp'' not found.'+LineEnding+'Check your installation.');
        {$IFDEF WINDOWS}
        Application.Initialize;
        {$ENDIF}
        Application.MessageBox(pTmp, 'Installation error', MB_OK);
        halt;
    end;
end;

end.

